import { Routes } from '@angular/router';
import { LoginComponent } from './login/login.component';
import { ClienteComponent } from './cliente/cliente.component';
import { LoginGuard } from './core/guards/login.guard';
import { ImagenesComponent } from './imagenes/imagenes.component';
import { PdfComponent } from './pdf/pdf.component';
import { NotfoundComponent } from './notfound/notfound.component';
import { DisignComponent } from './pdf/disign/disign.component';

export const routes: Routes = [
  {
    path: '',
    component: LoginComponent,
    // canActivate: [LoginGuard],
    title: 'Login',
  },
  {
    path: 'dashboard',
    loadChildren: () =>
      import('./dashboard/dasboard.routes').then(
        (ruta) => ruta.DASHBOARD_RUTAS
      ),
  },
  {
    path: 'casos-equipos',
    component: ClienteComponent,
  },

  {
    path: 'pdf',
    component: DisignComponent,
  },
  {
    path: 'imagenes',
    component: ImagenesComponent,
  },
  { path: '**', component: NotfoundComponent },
];
