import { Component, inject } from '@angular/core';
import { FormControl, FormGroup, ReactiveFormsModule } from '@angular/forms';
import { ServiceService } from '../core/service/service.service';
import { Etapa1GetComponent } from './etapa1-get/etapa1-get.component';
import { Etapa2GetComponent } from './etapa2-get/etapa2-get.component';
import { Etapa3GetComponent } from './etapa3-get/etapa3-get.component';
import { Etapa4GetComponent } from './etapa4-get/etapa4-get.component';
import { Etapa5GetComponent } from './etapa5-get/etapa5-get.component';
import { Etapa6GetComponent } from './etapa6-get/etapa6-get.component';
import { MensajeesperaComponent } from '../mensajeespera/mensajeespera.component';
import Swal from 'sweetalert2';

@Component({
  selector: 'app-cliente',
  standalone: true,
  imports: [
    ReactiveFormsModule,
    Etapa1GetComponent,
    Etapa2GetComponent,
    Etapa3GetComponent,
    Etapa4GetComponent,
    Etapa5GetComponent,
    Etapa6GetComponent,
    MensajeesperaComponent
  ],
  templateUrl: './cliente.component.html',
  styleUrl: './cliente.component.css',
})
export class ClienteComponent {
  apiService = inject(ServiceService);
  form: FormGroup = new FormGroup({
    buscador: new FormControl(''),
  });
  etapamodalget: number = 0;
  datos: any = [];
  url = import.meta.env.NG_APP_API + '/search-seguimiento-client';
  nrCaso: any = [];
  modal = false;
  etapa: number = 0;
  seguimiento: {
    idetapa: number;
    idetapainterna: number;
    idSeguimiento: string;
  }[] = [];
  estadosingarantia: boolean = false;
  llaveloading: boolean = false;
  estadoetapa3rechazado: boolean = false;
  estadoetapa6completado: boolean = false;
  calificacionetapa6: number = 0;

  enviarDatos(e: any) {
    // Accede al valor del control 'buscador' directamente desde el formulario reactivo
    this.datos = [];
    const searchData = this.form.get('buscador')?.value.replace(/\s+/g, '');
    this.nrCaso = { nrCaso: searchData };
    console.log('Datos enviados:', this.nrCaso);
    this.llaveloading = !this.llaveloading;
    this.apiService.postApi(this.url, this.nrCaso).subscribe({
      next: (data) => {
        console.log(data.caso.garantia);
        if (data.caso.garantia == 'true') {
          this.etapa = 0;
          this.estadosingarantia = false;
          this.estadoetapa3rechazado = false;
          this.estadoetapa6completado = false;
          this.seguimiento = [
            { idetapa: 1, idetapainterna: 1, idSeguimiento: '' },
            { idetapa: 2, idetapainterna: 2, idSeguimiento: '' },
            { idetapa: 3, idetapainterna: 3, idSeguimiento: '' },
            { idetapa: 4, idetapainterna: 4, idSeguimiento: '' },
            { idetapa: 5, idetapainterna: 5, idSeguimiento: '' },
            { idetapa: 6, idetapainterna: 6, idSeguimiento: '' },
            { idetapa: 7, idetapainterna: 7, idSeguimiento: '' },
            { idetapa: 8, idetapainterna: 8, idSeguimiento: '' },
       
          ];
          console.log(data.caso.garantia);
          this.estadosingarantia = !this.estadosingarantia;

          data.seguimientos.forEach((seg: any, i: any) => {
            const idEtapaActual = seg.etapa.id;
            if (idEtapaActual === 3) {
              if (seg.estadoSeguimiento === "Rechazado") {
                this.estadoetapa3rechazado = true;
              }
            }
            if (idEtapaActual === 6) {
              if (seg.estadoSeguimiento === "Completado") {
                this.estadoetapa6completado = true;
                this.calificacionetapa6 = seg.calificacion;
              }
            }
            this.seguimiento[seg.etapa.id - 1].idSeguimiento =
              seg.idSeguimiento;
            if (idEtapaActual > this.etapa) {
              //this.etapa = idEtapaActual;
              this.etapa = this.seguimiento[idEtapaActual - 1].idetapa;
            }
            console.log(this.seguimiento);
            console.log(this.etapa);
          });
        } else {
          this.etapa = 0;
          this.estadosingarantia = false;
          this.estadoetapa3rechazado = false;
          this.estadoetapa6completado = false;
          this.seguimiento = [
            { idetapa: 1, idetapainterna: 1, idSeguimiento: '' },
            { idetapa: 2, idetapainterna: 2, idSeguimiento: '' },
            { idetapa: 3, idetapainterna: 3, idSeguimiento: '' },
            { idetapa: 4, idetapainterna: 4, idSeguimiento: '' },
            { idetapa: 5, idetapainterna: 5, idSeguimiento: '' }, 
            { idetapa: 6, idetapainterna: 6, idSeguimiento: '' },
            { idetapa: 7, idetapainterna: 7, idSeguimiento: '' },
            { idetapa: 8, idetapainterna: 8, idSeguimiento: '' },
          ];
          data.seguimientos.forEach((seg: any, i: any) => {
            const idEtapaActual = seg.etapa.id;
            if (idEtapaActual === 3) {
              if (seg.estadoSeguimiento === "Rechazado") {
                this.estadoetapa3rechazado = true;
              }
            }
            if (idEtapaActual === 6) {
              if (seg.estadoSeguimiento === "Completado") {
                this.estadoetapa6completado = true;
                this.calificacionetapa6 = seg.calificacion;
              }
            }
            this.seguimiento[seg.etapa.id - 1].idSeguimiento =
              seg.idSeguimiento;
            if (idEtapaActual > this.etapa) {
              //this.etapa = idEtapaActual;
              this.etapa = this.seguimiento[idEtapaActual - 1].idetapa;
            }
          });
        }
        this.datos = data;
        this.llaveloading = !this.llaveloading;
      },
      error: (error) => {
        Swal.fire({
          title: 'Error al buscar el caso!',
          text: 'Número de caso no existe o no se encuentra disponible.',
          icon: 'error',
          confirmButtonText: 'OK',
        });
        console.log(error);
        this.llaveloading = !this.llaveloading;
      },
    });
  }

  mostrarmodal(etapa: number) {
    this.etapamodalget = etapa;
    this.modal = !this.modal;
  }

  redirectToDatatronica(event: Event) {
    event.preventDefault();
    window.open('https://datatronicaperu.com/', '_blank');
  }

  llaveloadingfuntion() {
    this.llaveloading = !this.llaveloading;
  }

  //para las estrellas
  stars = [
    { value: 0, icon: 'star' },
    { value: 1, icon: 'star' },
    { value: 2, icon: 'star' },
    { value: 3, icon: 'star' },
    { value: 4, icon: 'star' }
  ];
}
