import { Component, Input } from '@angular/core';
import { ServiceService } from '../../core/service/service.service';
import { CommonModule } from '@angular/common';

@Component({
  selector: 'app-etapa4-get',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './etapa4-get.component.html',
  styleUrl: './etapa4-get.component.css'
})
export class Etapa4GetComponent {

  @Input() datos: any = {}; // Cambiado de any[] a any
  seguimientoetapa4: any[] = []
  idCaso: number = 0;
  casos: any
  imagenes: any[] = []
  videos: any[] = []
  distribuidor: any[] = []
  archivosPDFS: any[] = []
  urlMedia = import.meta.env.NG_APP_API + '/media/'
  urlsPds = import.meta.env.NG_APP_API + '/download-pdf/'

  archivoPdfRepuestos: any

  fechaFormateada: any

  mostraImpresoraDatos: number = 0

  desarrollo: any

  descripcionRepuestos: string = ''
  observaciones: string = ''

  estadoCaso: any

  ngOnInit(): void {
    if (this.datos && this.datos.caso) {
      this.casos = this.datos;
      console.log(this.casos);
      this.desarrollo = this.datos.desarrollo;
      this.idCaso = this.datos.caso.id;

   

      // Imágenes y videos relacionados con el desarrollo
      if (this.datos.desarrollo && this.datos.desarrollo.media) {
        this.imagenes = this.datos.desarrollo.media.imagenes || [];
        this.videos = this.datos.desarrollo.media.videos || [];
      }

      // Seguimiento de la etapa 4
      if (this.datos.seguimientos) {
        this.seguimientoetapa4 = this.datos.seguimientos.filter((item: any) => item.etapa.id === 4);

        if (this.seguimientoetapa4.length > 0) {
          this.descripcionRepuestos = this.seguimientoetapa4[0].descripcion || '';
          this.observaciones = this.seguimientoetapa4[0].observacion || '';
          this.estadoCaso = this.seguimientoetapa4[0].estadoSeguimiento || '';
        } else {
          this.descripcionRepuestos = '';
          this.observaciones = '';
        }
      } else {
        this.seguimientoetapa4 = [];
        this.descripcionRepuestos = '';
        this.observaciones = '';
      }
    } else {
      // Datos no válidos o no proporcionados
      console.warn('No se proporcionaron datos válidos.');
      this.casos = null;
      this.desarrollo = null;
      this.idCaso = 0;
      this.estadoCaso = null;
      this.imagenes = [];
      this.videos = [];
      this.seguimientoetapa4 = [];
      this.descripcionRepuestos = '';
      this.observaciones = '';
    }
  }

}
