import { HttpClient, HttpErrorResponse } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { catchError, Observable, throwError } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class ServiceService {
  constructor(private http: HttpClient) {}

  postLogin(urlApi: string, datosRecolectados: any): Observable<any> {
    // Asegúrate de que la solicitud HTTP devuelve un objeto de tipo interfaceLogin
    const respuesta = this.http.post<any>(urlApi, datosRecolectados);
    return respuesta;
  }

  // Método para realizar la consulta a la API
  public getApi(url: string): Observable<any> {
    return this.http.get(url);
  }

  public postApi(url: string, datos: any): Observable<any> {
    return this.http.post(url, datos);
  }

  public putApi(url: string, datos: any): Observable<any> {
    return this.http.put(url, datos);
  }

  public deleteApi(url: string): Observable<any> {
    return this.http.delete(url);
  }


 
  

  // Otros métodos como getApi, putApi, deleteApi, etc.



  logout() {
    localStorage.removeItem('token');
  }
}
