import {
  Component,
  ElementRef,
  EventEmitter,
  HostListener,
  OnInit,
  Output,
  inject,
} from '@angular/core';
import AuthService from '../../../core/auth/auth.service';
import { CambiarcontraComponent } from './cambiarcontra/cambiarcontra.component';

@Component({
  selector: 'app-navbar',
  standalone: true,
  imports: [CambiarcontraComponent],
  templateUrl: './navbar.component.html',
  styleUrl: './navbar.component.css',
})
export class NavbarComponent {
 
  usuario: any
  rol: any

  constructor(private elementRef: ElementRef) {
    this.checkScreenSize();
    const authService = inject(AuthService);
    const decode = authService.decodeToken();
    if (decode) {
      this.usuario = decode.sub;
      this.rol = decode.roles;
    }
  }

  ngOnInit(): void {
    this.showSidebar = !this.showSidebar;
    this.addshowSidebarEvent.emit(this.showSidebar);
    this.checkScreenSize();
  }

  showSidebar: boolean = false;
  //se declara para enviar iformacion al padre, se tiene que indicar que tipo de variable le vamos a pasar
  @Output() addshowSidebarEvent = new EventEmitter<boolean>();
  //creamos un metodo para output
  show() {
    this.showSidebar = !this.showSidebar;
    this.addshowSidebarEvent.emit(this.showSidebar);
  }

  @HostListener('window:resize', ['$event'])
  onResize(event: any) {
    this.checkScreenSize(); // Llamar al método cuando cambie el tamaño de la pantalla
  }

  private checkScreenSize() {
    if (window.innerWidth >= 640) {
      this.show();
    }
  }

  clickOptions2: boolean = false;

  clickOptions() {
    this.clickOptions2 = !this.clickOptions2;
  }

  @HostListener('document:click', ['$event'])
  onClick(event: MouseEvent) {
    if (!this.elementRef.nativeElement.contains(event.target)) {
      // Llamar a la función showSettings() cuando se hace clic fuera del elemento
      if (this.clickOptions2 === true) {
        this.clickOptions();
      }
    }
  }

  salir() : any {
      localStorage.removeItem('token');
      window.location.href = '/';
  }
}
