import { Routes } from '@angular/router';
import { LayoutComponent } from './components/layout/layout.component';
import { DashboardComponent } from './dashboard.component';
import { guardGuard } from '../core/guards/guard.guard';
import { FallasComponent } from './fallas/fallas.component';
import { PerfilespermisosComponent } from './modules/seguridad/perfilespermisos/perfilespermisos.component';
import { UsuariosComponent } from './modules/seguridad/usuarios/usuarios.component';
import { TablacasosComponent } from './modules/casos/casos/tablacasos/tablacasos.component';
import { DistribuidorComponent } from './modules/casos/distribuidor/distribuidor.component';
import { CasosComponent } from './modules/casos/casos/casos.component';
import { EquiposComponent } from './modules/casos/equipos/equipos.component';
import { PrioridadatencionComponent } from './modules/casos/prioridadatencion/prioridadatencion.component';
import { TablaprioridadatencionComponent } from './modules/casos/prioridadatencion/tablaprioridadatencion/tablaprioridadatencion.component';
import { TipoMantenimientoComponent } from './tipo-mantenimiento/tipo-mantenimiento.component';
import { SeguimientoComponent } from '../seguimiento/seguimiento.component';
import { ReportesComponent } from './reportes-tecnicos/reportes.component';
import { ReportesAuditoriaComponent } from './reportes-auditoria/reportes-auditoria.component';
import { ReportesFechasComponent } from './reportes-fechas/reportes-fechas.component';
import { ReportesCalificacionComponent } from './reportes-calificacion/reportes-calificacion.component';
import { ReportesCasosGarantiaComponent } from './reportes-casos-garantia/reportes-casos-garantia.component';
import { ReporteFechasMantenimientoComponent } from './reporte-fechas-mantenimiento/reporte-fechas-mantenimiento.component';
import { SeguimientoEditarComponent } from '../seguimiento-editar/seguimiento-editar.component';
import { PermisosComponent } from './modules/seguridad/permisos/permisos.component';
import { DiagnosticoComponent } from '../seguimiento/etapa3/diagnostico/diagnostico.component';
import { Abriretapa2Component } from '../seguimiento/etapa2/abriretapa2/abriretapa2.component';
import { DesarrolloComponent } from '../seguimiento/etapa4/desarrollo/desarrollo.component';
import { ClientsComponent } from './modules/casos/clients/clients.component';
import { RespuestacasnumerodecasoComponent } from '../seguimiento/etapa2/respuestacasnumerodecaso/respuestacasnumerodecaso.component';
import { DisignComponent } from '../pdf/disign/disign.component';
import { Etapa1EditarComponent } from '../seguimiento-editar/etapa1-editar/etapa1-editar.component';
import { ReportesCasComponent } from './reportes-cas/reportes-cas.component';
import { PdfComponent } from '../pdf/pdf.component';
import { ReportesSucursalesComponent } from './reportes-sucursales/reportes-sucursales.component';
import { PedirplantillaComponent } from '../seguimiento/etapa-solo-brothers/pedirplantilla/pedirplantilla.component';
import { CambiarcontraComponent } from './components/navbar/cambiarcontra/cambiarcontra.component';
import { Abriretapa4seguimientoComponent } from '../seguimiento/etapa4/abriretapa4seguimiento/abriretapa4seguimiento.component';
import { ManualesComponent } from './modules/casos/manuales/manuales.component';
import { SucursalesComponent } from './modules/casos/sucursales/sucursales.component';
import { TablaCasosPorFallaComponent } from './fallas/tabla-casos-por-falla/tabla-casos-por-falla.component';

export const DASHBOARD_RUTAS: Routes = [
  {
    path: '',
    canActivate: [guardGuard],
    data: {
      permisoRol: [
        'ADMIN',
        'USUARIO',
        'SOPORTE',
        'ASISTENTE',
        'DISTRIBUIDOR',
        'SUPERVISOR',
      ],
    },
    component: LayoutComponent,
    children: [
      {
        path: '',
        component: DashboardComponent,
        canActivate: [guardGuard],
        data: {
          permisoRol: [
            'ADMIN',
            'ASISTENTE',
            'SOPORTE',
            'DISTRIBUIDOR',
            'SUPERVISOR',
          ],
        },
      },
      {
        path: 'perfiles',
        component: PerfilespermisosComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN', 'SOPORTE'] },
      },
      {
        path: 'usuarios',
        component: UsuariosComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN', 'SOPORTE'] },
      },
      {
        path: 'permisos',
        component: PermisosComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN', 'SOPORTE'] },
      },
      {
        path: 'reportes-tecnicos',
        component: ReportesComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-garantia',
        component: ReportesCasosGarantiaComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-casos-mantenimiento',
        component: ReporteFechasMantenimientoComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-auditoria',
        component: ReportesAuditoriaComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-fechas',
        component: ReportesFechasComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-calificacion',
        component: ReportesCalificacionComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-sucursales',
        component: ReportesSucursalesComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'reportes-cas',
        component: ReportesCasComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'clientes',
        component: ClientsComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN', 'ASISTENTE', 'SOPORTE'] },
      },

      // registar el caso
      {
        path: 'casos',
        component: CasosComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'ASISTENTE', 'SOPORTE'] },
      },

      {
        path: 'casos-total',
        component: TablacasosComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN'] },
      },

      {
        path: 'equipos',
        component: EquiposComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },

      {
        path: 'distribuidores',
        component: DistribuidorComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },

      {
        path: 'prioridad-atencion',
        component: PrioridadatencionComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },

      {
        path: 'lista-prioridad-atencion',
        component: TablaprioridadatencionComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },
      {
        path: 'fallas',
        component: FallasComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },
      {
        path: 'manuales',
        component: ManualesComponent,
        // canActivate: [guardGuard],
        // data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },
      {

        path: 'sucursales',
        component: SucursalesComponent

      },
      {
        path: 'tipo-mantenimiento',
        component: TipoMantenimientoComponent,
        canActivate: [guardGuard],
        data: { permisoRol: ['ADMIN', 'SOPORTE', 'ASISTENTE'] },
      },
      {
        path: 'seguimiento',
        component: SeguimientoComponent,
        canActivate: [guardGuard],
        data: {
          permisoRol: [
            'ADMIN',
            'ASISTENTE',
            'SOPORTE',
            'DISTRIBUIDOR',
            'SUPERVISOR',
          ],
        },
      },
      {
        path: 'seguimiento-editar',
        component: SeguimientoEditarComponent,
        data: { permisoRol: ['ADMIN'] },
      },
      {
        path: 'seguimiento-por-falla',
        component: TablaCasosPorFallaComponent,
        canActivate: [guardGuard],
        data: {
          permisoRol: [
            'ADMIN',
            'ASISTENTE',
            'SOPORTE',
            'DISTRIBUIDOR',
            'SUPERVISOR',
          ],
        },
      },
      {
        path: 'passwordchange',
        component: CambiarcontraComponent,
        canActivate: [guardGuard],
        data: {
          permisoRol: [
            'DISTRIBUIDOR',
          ],
        },
      },
      {
        path: 'pdf',
        component: DisignComponent,
      },
      {
        path: 'cahuide',
        component: Abriretapa4seguimientoComponent,
      },
    ],
    title: 'Admin',
  },
];
