import { Component } from '@angular/core';
import { FormControl, FormGroup, ReactiveFormsModule } from '@angular/forms';
import { ServiceService } from '../../core/service/service.service';
import Swal from 'sweetalert2';
import { PostEtapasInterface } from './datos';



@Component({
  selector: 'app-etapas',
  standalone: true,
  imports: [ReactiveFormsModule],
  templateUrl: './etapas.component.html',
  styleUrl: './etapas.component.css'
})
export class EtapasComponent{

  constructor(private servicioApi: ServiceService) { }

  // No es necesario definir una propiedad adicional

  form: FormGroup = new FormGroup({
    nombre: new FormControl('')
  });

  enviarDatos() {
    // Utiliza directamente el valor del FormControl
    const nombre: string = this.form.get('nombre')?.value;

    const formulario: PostEtapasInterface = {
      nombre: nombre,
    };

    const url = import.meta.env.NG_APP_API + "/etapas";
    this.servicioApi.postApi(url, formulario).subscribe({
      next: (data) => {
        console.log(data);
        window.location.reload();
      },
      error: (error) => {
        console.log(error);
      }
    });
  }
}