import { Component, OnInit, inject } from '@angular/core';
import { ServiceService } from '../../../../core/service/service.service';
import { UpdatepermisosComponent } from './updatepermisos/updatepermisos.component';

@Component({
  selector: 'app-permisos',
  standalone: true,
  imports: [UpdatepermisosComponent],
  templateUrl: './permisos.component.html',
  styleUrl: './permisos.component.css',
})
export class PermisosComponent implements OnInit {
  usuarios: any[] = [];
  idUsuario! : number
  estadomodalActualizar: boolean = false;
  url = import.meta.env.NG_APP_API + '/usuarios';

  private dataservie = inject(ServiceService);
  ngOnInit(): void {
    this.getUsuarios();
  }

  getUsuarios() {
    this.dataservie.getApi(this.url).subscribe({
      next: (data) => {
        this.usuarios = data;
      },
      error: (error) => {
        console.log(error);
      },
    });
  }
  abremodalActualizar(id:number){
    this.idUsuario = id;
    this.estadomodalActualizar = !this.estadomodalActualizar;

  }

  abremodal(show: boolean) {
    this.estadomodalActualizar = !this.estadomodalActualizar;
  }

  previousPage() {}

  nextPage() {}
}
