import {
  Component,
  EventEmitter,
  Input,
  OnInit,
  Output,
  inject,
} from '@angular/core';
import { ServiceService } from '../../../../../core/service/service.service';

@Component({
  selector: 'app-updatepermisos',
  standalone: true,
  imports: [],
  templateUrl: './updatepermisos.component.html',
  styleUrl: './updatepermisos.component.css',
})
export class UpdatepermisosComponent implements OnInit {
  @Input() id!: number;
  @Output() addshowModalEvent = new EventEmitter<boolean>();
  service = inject(ServiceService);
  allmodulosWithPermisos: any[] = [];
  modulosWithPermisosOfUsuario: any[] = [];
  isLoading : boolean =true
  url = import.meta.env.NG_APP_API + '/perfiles';
  url2 = import.meta.env.NG_APP_API + '/usuarios';
  ngOnInit(): void {
    this.getAllModulosWithPermisosbyPerfil();
    this.getModulosWithPermisosOfUsuario();
  }
  showmodalclose(show: boolean) {
    this.addshowModalEvent.emit(show);
  }

  getAllModulosWithPermisosbyPerfil() {
    this.isLoading = true;
    this.service
      .postApi(this.url + '/modulos-permissions', {
        idusuario: this.id,
      })
      .subscribe({
        next: (data) => {
          console.log('en general', data);
          this.allmodulosWithPermisos = data.modulos;
          this.markSelectedPermisos();
          this.isLoading = false;
        },
        error: (error) => {
          console.log(error);
          this.isLoading=false
        },
      });
  }
  getModulosWithPermisosOfUsuario() {
    this.isLoading=true
    this.service
      .postApi(this.url2 + '/permisos', {
        idusuario: this.id,
      })
      .subscribe({
        next: (data) => {
          console.log('del usuario', data);
          this.modulosWithPermisosOfUsuario = data;
          this.markSelectedPermisos();
          this.isLoading=false
        },
        error: (error) => {
          console.log(error);
          this.isLoading=false
        },
      });
  }
  markSelectedPermisos() {
    if (this.allmodulosWithPermisos.length>0 && this.modulosWithPermisosOfUsuario.length>0) {
      this.allmodulosWithPermisos.forEach((modulo) => {
        modulo.permisos.forEach((permiso: any) => {
          permiso.checked = this.modulosWithPermisosOfUsuario.some(
            (usuarioModulo) =>
              usuarioModulo.permisos.some(
                (usuarioPermiso: any) => usuarioPermiso.id === permiso.id
              )
          );
        });
      });
    }
  }
  onChange(e: any, permiso: any, modulo: any) {
    permiso.checked = e.target.checked;
    this.updateSelectAll(modulo);
  }
  selectAll(event: any, modulo: any) {
    const checked = event.target.checked;
    modulo.permisos.forEach((permiso: any) => {
      permiso.checked = checked;
    });
  }

  areAllSelected(modulo: any): boolean {
    return modulo.permisos.every((permiso: any) => permiso.checked);
  }

  updateSelectAll(modulo: any) {
    const allSelected = this.areAllSelected(modulo);
    const selectAllCheckbox = document.getElementById(`select-all-${modulo.id}`) as HTMLInputElement;
    if (selectAllCheckbox) {
      selectAllCheckbox.checked = allSelected;
    }
  }
  enviarDatos(e: any) {
    this.isLoading=true
    e.preventDefault();
    const permisosSeleccionados = this.allmodulosWithPermisos
      .flatMap(modulo => modulo.permisos)
      .filter(permiso => permiso.checked)
      .map(permiso => permiso.id);
    
    console.log(permisosSeleccionados)
    this.service
      .postApi(this.url2 + '/asignarpermisos', {
        idusuario: this.id,
        idpermisos: permisosSeleccionados,
      })
      .subscribe({
        next: (data) => {
          console.log(data);
          this.isLoading=false
          this.showmodalclose(false);
          window.location.reload()
        },
        error: (error) => {
          alert(error);
          this.isLoading=false
        },
      });


  }
}
