import {
  Component,
  ElementRef,
  EventEmitter,
  OnInit,
  Output,
} from '@angular/core';
import { SeguimientoDatosByIdService } from '../../dashboard/modules/casos/casos/tablacasos/seguimientodatosbyid';
import { CommonModule } from '@angular/common';
@Component({
  selector: 'app-disign',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './disign.component.html',
  styleUrl: './disign.component.css',
})
export class DisignComponent implements OnInit {
  modal = false;
  seguimientoetapa1: any[] = [];
  seguimientoetapa2: any[] = [];
  seguimientoetapa3: any[] = [];
  seguimientoetapa4: any[] = [];
  seguimientoetapa5: any[] = [];
  seguimientoetapa6: any[] = [];
  seguimientoetapa7: any[] = [];

  constructor(private seguimietoDatos: SeguimientoDatosByIdService) {}

  ngOnInit(): void {
    this.postNombreCasoParaTraerLosSeguimientos();
  }

  mostrarmodal(etapa: string, estado: string) {
    this.modal = !this.modal;
  }

  cerrarmodal() {
    this.modal = !this.modal;
  }

  datosSeguimientoId: any = [];
  nombreCaso: any = '';
  estadoGarantia: any = '';
  repuestos: any = '';
  fechaInicioEtapa1: any;
  fechaInicioEtapa6: any;

  tipodeServicio: any;
  descripcionDiagnostico: any;
  descripcionDesarrollo: any;
  descripcionPruebasdeCalidad: any;

  descripcionnumerodeCaso: any;

  descripcionnumerodeCaso2: any;

  fechaSplitMantenimiento: any;
  anioMantenimiento: any;
  mesMantenimiento: any;
  diaMantenimiento: any;
  fechadeMantenimiento: any;

  anioFecha1: any;
  mesFecha1: any;
  diaFecha1: any;
  fecha1: any;

  anioFecha6: any;
  mesFecha6: any;
  diaFecha6: any;
  fecha16: any;

  numerodeCasodelCas: any;
  numerodeCasoDatatronica: any;

  fallas: any = [];

  tipodeMantenimiento: any;

  descripciondeRepuestos: any;

  observacionesdeEntrada :any
  observacionesPruebasdeCalidad :any

  postNombreCasoParaTraerLosSeguimientos() {
    const numerocaso = localStorage.getItem('numerocaso');
    if (!numerocaso) {
      console.error('Número de caso no encontrado en el almacenamiento local.');
      return;
    }

    const url = import.meta.env.NG_APP_API + '/search-seguimiento-client';
    this.nombreCaso = numerocaso;
    const datos = { nrCaso: numerocaso };

    this.seguimietoDatos.postApi(url, datos).subscribe({
      next: (data) => {
        this.datosSeguimientoId = data;
        console.log('Datos de seguimiento por ID:', this.datosSeguimientoId);

        this.tipodeServicio = this.datosSeguimientoId?.caso?.tipoServicio.toUpperCase() || '';

        this.descripcionDiagnostico = this.datosSeguimientoId?.diagnostico?.descripcion?.toUpperCase() || '';
        this.descripcionDesarrollo = this.datosSeguimientoId?.desarrollo?.descripcion?.toUpperCase() || '';
        this.descripcionPruebasdeCalidad = this.datosSeguimientoId?.pruebaCalidad?.descripcion?.toUpperCase() || '';
        
        // Dividir la fecha
        if (this.datosSeguimientoId?.caso?.proximoMantenimiento) {
          this.fechaSplitMantenimiento = this.datosSeguimientoId.caso.proximoMantenimiento.split('-');

          // Obtener los componentes de la fecha
          this.anioMantenimiento = this.fechaSplitMantenimiento[0];
          this.mesMantenimiento = this.fechaSplitMantenimiento[1];
          this.diaMantenimiento = this.fechaSplitMantenimiento[2];

          // Reconstruir la fecha en formato día-mes-año
          this.fechadeMantenimiento = `${this.diaMantenimiento}-${this.mesMantenimiento}-${this.anioMantenimiento}`;
          console.log(this.fechadeMantenimiento); // Para verificar la fecha reconstruida
        }

        this.seguimientoetapa1 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 1) || [];
        this.seguimientoetapa2 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 2) || [];
        this.seguimientoetapa3 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 3) || [];
        this.seguimientoetapa4 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 4) || [];
        this.seguimientoetapa5 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 5) || [];
        this.seguimientoetapa6 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 6) || [];
        this.seguimientoetapa7 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 7) || [];

        this.descripciondeRepuestos = this.datosSeguimientoId?.diagnostico?.descripcionRepuestos?.toUpperCase() || '';
        this.observacionesdeEntrada = this.datosSeguimientoId?.caso?.observaciones || '';
        this.tipodeMantenimiento = this.datosSeguimientoId?.diagnostico?.tipomantenimiento?.descripcion?.toUpperCase() || '';

        this.observacionesPruebasdeCalidad = this.datosSeguimientoId?.pruebaCalidad?.observaciones?.toUpperCase() || '';
        this.fallas = this.datosSeguimientoId?.diagnostico?.fallas || [];




        this.numerodeCasoDatatronica = this.datosSeguimientoId?.caso?.numeroCaso || '';
        this.numerodeCasodelCas = this.seguimientoetapa2[0]?.nroCasoMarca || '';
        console.log(this.numerodeCasodelCas, this.numerodeCasoDatatronica);

        this.descripcionnumerodeCaso = this.seguimientoetapa2[0]?.descripcion?.toUpperCase() || '';

        this.estadoGarantia = data.diagnostico?.estadoGarantia || '';
        this.repuestos = this.seguimientoetapa4[0]?.repuestos || '';


        if (this.datosSeguimientoId?.seguimientos[0]?.fechaInicio) {
          this.fechaInicioEtapa1 = this.datosSeguimientoId.seguimientos[0].fechaInicio.split('-');

          this.anioFecha1 = this.fechaInicioEtapa1[0];
          this.mesFecha1 = this.fechaInicioEtapa1[1];
          this.diaFecha1 = this.fechaInicioEtapa1[2];

          this.fecha1 = `${this.diaFecha1}-${this.mesFecha1}-${this.anioFecha1}`;
          console.log(this.fecha1);
        }

        if (this.seguimientoetapa6[0]?.fechaFin) {
          this.fechaInicioEtapa6 = this.seguimientoetapa6[0].fechaFin.split('-');

          this.anioFecha6 = this.fechaInicioEtapa6[0];
          this.mesFecha6 = this.fechaInicioEtapa6[1];
          this.diaFecha6 = this.fechaInicioEtapa6[2];

          this.fecha16 = `${this.diaFecha6}-${this.mesFecha6}-${this.anioFecha6}`;
        }

  
      },
      error: (error) => {
        console.error('Error al traer los datos de seguimiento', error);
      },
    });
  }
}