import { ChangeDetectorRef, Component, Input } from '@angular/core';
import { ServiceService } from '../../core/service/service.service';
import { FormControl, FormGroup, ReactiveFormsModule } from '@angular/forms';
import Swal from 'sweetalert2';

@Component({
  selector: 'app-etapa3-editar',
  standalone: true,
  imports: [ReactiveFormsModule],
  templateUrl: './etapa3-editar.component.html',
  styleUrl: './etapa3-editar.component.css'
})
export class Etapa3EditarComponent {
  constructor(private dataService: ServiceService, private cdr: ChangeDetectorRef) { }
  loading: boolean = false;
  datos_casos: any;
  imagenes: any = [];
  imagenesBackend: any = [];

  @Input() datos: any = {};
  datos_diagnostico : any
  mostrarModal: boolean = false;
  fieldlocked: boolean = true;
  imagenSeleccionada: string = '';

  arreglogetCliente: any[] = [];
  arreglogetUsuarios: any[] = [];
  arreglogetPrioridad: any[] = [];

  arreglogetEquipos: any[] = [];
  arreglogetDistribuidor: any[] = [];

  equiposFiltrados: any[] = [];

  dni: string = '';
  urlMedia = import.meta.env.NG_APP_API + '/media/'
  seguimientoetapa3: any[] = [];
  id_etapa : any


  valorTiempoEspera : any

  validarTiempoDeLlegadadeRepuestos(event: any) {


    const inputValue = event.target.value;
    const numericValue = inputValue.replace(/\D/g, ''); // Elimina caracteres no numéricos
    const truncatedValue = numericValue.substring(0, 2); // Limita la longitud a 8 dígitos
    event.target.value = truncatedValue;
    
    this.formularioSeguimiento.patchValue({ llegadaDiasRepuesto: truncatedValue });
  }

  formularioDiagnostico = new FormGroup({
    seguimientoId: new FormControl(0),
    descripcion: new FormControl(""),
    caracteristicasEquipo: new FormControl(""),
    detalleConsumibles: new FormControl(""),
    descripcionRepuestos: new FormControl(0),
    tipoMantenimientoId: new FormControl(""),
  });

  formularioSeguimiento = new FormGroup({
    idCaso: new FormControl(0),
    descripcion: new FormControl(""),
    observacion: new FormControl(""),
    repuestos: new FormControl(""),
    llegadaDiasRepuesto: new FormControl(0),
    conformidadDeServicio: new FormControl(""),
    calificacion: new FormControl(""),
    nroCasoMarca: new FormControl(""),
    fechaInicio: new FormControl(""),
    fechaFin: new FormControl(""),
    horaInicio: new FormControl(""),
    horaFin: new FormControl(""),
    estadoSeguimiento: new FormControl(""),
    idEtapa: new FormControl(0)  // Change this to FormControl
  });


  recogerTiempoRepuestos : any

  verSiEsImpresora:any
  repuestosMostrar : any


  id_diagnostico: any = 0;

  ngOnInit(): void {
    this.getFallas()
    this.getMantenimiento()

    this.datos_casos = this.datos.caso;


    
    
    this.datos_diagnostico = this.datos.diagnostico;

  
    this.seguimientoetapa3 = this.datos.seguimientos.filter(
      (item: any) => item.etapa.id === 3
    );
    this.id_etapa= this.seguimientoetapa3[0].etapa.id
    console.log(this.id_etapa)
    
    this.verSiEsImpresora = this.datos_diagnostico.detalleConsumibles || ''
    this.repuestosMostrar = this.datos_diagnostico.descripcionRepuestos 

  
    this.id_diagnostico = this.datos_diagnostico.id || 0;

   

    this.recogerTiempoRepuestos=  String(this.seguimientoetapa3[0]?.llegadaDiasRepuesto) || '',


    this.formularioDiagnostico.patchValue({
      seguimientoId: this.seguimientoetapa3[0].idSeguimiento|| 0,
      descripcion : this.datos_diagnostico.descripcion,
      descripcionRepuestos: this.datos_diagnostico.descripcionRepuestos,
      detalleConsumibles: this.datos_diagnostico.detalleConsumibles,
      caracteristicasEquipo: this.datos_diagnostico.caracteristicasEquipo,
      tipoMantenimientoId: this.datos_diagnostico.tipomantenimiento.id

    });


    this.formularioSeguimiento.patchValue({
      idCaso: this.datos_casos.id || 0,
      idEtapa: this.id_etapa,
      descripcion: this.seguimientoetapa3[0]?.descripcion || '',
      observacion: this.seguimientoetapa3[0]?.observacion || '',
      repuestos: this.seguimientoetapa3[0]?.repuestos || '',
      llegadaDiasRepuesto: this.seguimientoetapa3[0]?.llegadaDiasRepuesto || 0,
      conformidadDeServicio: this.seguimientoetapa3[0]?.conformidadDeServicio || '',
      calificacion: this.seguimientoetapa3[0]?.calificacion || "",
      nroCasoMarca: this.seguimientoetapa3[0]?.nroCasoMarca || '',
      fechaInicio: this.seguimientoetapa3[0]?.fechaInicio || '',
      fechaFin: this.seguimientoetapa3[0]?.fechaFin || '',
      horaInicio: this.seguimientoetapa3[0]?.horaInicio || '',
      horaFin: this.seguimientoetapa3[0]?.horaFin || '',
      estadoSeguimiento: this.seguimientoetapa3[0]?.estadoSeguimiento || '',
    });

  }



  arregloMantenimiento: any = [];
  getMantenimiento() {
    const url = import.meta.env.NG_APP_API + '/tipoMantenimiento';
    this.dataService.getApi(url).subscribe({
      next: (data) => {
        this.arregloMantenimiento = data;
      },
      error: (error) => {
        console.error('There was an error!', error);
      },
    });
  }

  arregloFallas: any = [];
  getFallas() {
    const url = import.meta.env.NG_APP_API + '/fallas';
    this.dataService.getApi(url).subscribe({
      next: (data) => {
        this.arregloFallas = data.content;
      },
      error: (error) => {
        console.error('There was an error!', error);
      },
    });
  }


  actualizarDatos(){
    this.loading = true;
    const formData = new FormData();
    const valoresFormulario = this.formularioDiagnostico.getRawValue();
  
    // Convertir todos los valores a string y agregarlos a formData
    for (const [key, value] of Object.entries(valoresFormulario)) {
      formData.append(key, value !== null && value !== undefined ? String(value) : '');
    }
  
    const url = `${import.meta.env.NG_APP_API}/diagnostico/${ this.id_diagnostico}`;
  
    this.dataService.putApi(url, formData).subscribe({
      next: (data) => {

       this.actualizarSeguimiento()
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }
  


  actualizarSeguimiento() {
    this.loading = true;
    const formData = new FormData();
    const valoresFormulario = this.formularioSeguimiento.getRawValue();
  
    // Convertir todos los valores a string y agregarlos a formData
    for (const [key, value] of Object.entries(valoresFormulario)) {
      formData.append(key, value !== null && value !== undefined ? String(value) : '');
    }
  
    const url = `${import.meta.env.NG_APP_API}/seguimiento/${ this.seguimientoetapa3[0]?.idSeguimiento}`;
  
    this.dataService.putApi(url, formData).subscribe({
      next: (data) => {
        this.loading = false;
        Swal.fire({
          icon: 'success',
          title: '¡Registro actualizado!',
          text: 'Los datos se han actualizado correctamente.',
        }).then(() => {
          window.location.reload();
        });
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }
}

