import { Component } from '@angular/core';
import { SeguimientoDatosByIdService } from '../dashboard/modules/casos/casos/tablacasos/seguimientodatosbyid';
import { EditCasoComponent } from '../dashboard/modules/casos/casos/edit-caso/edit-caso.component';
import { Etapa1EditarComponent } from './etapa1-editar/etapa1-editar.component';
import { CommonModule } from '@angular/common';
import { Etapa2EditarComponent } from './etapa2-editar/etapa2-editar.component';
import AuthService from '../core/auth/auth.service';
import { Etapa3EditarComponent } from './etapa3-editar/etapa3-editar.component';
import { Etapa4EditarComponent } from './etapa4-editar/etapa4-editar.component';
import { Etapa5EditarComponent } from './etapa5-editar/etapa5-editar.component';
import Swal from 'sweetalert2';

@Component({
  selector: 'app-seguimiento-editar',
  standalone: true,
  imports: [Etapa1EditarComponent, CommonModule, Etapa2EditarComponent, Etapa3EditarComponent, Etapa4EditarComponent, Etapa5EditarComponent],
  templateUrl: './seguimiento-editar.component.html',
  styleUrl: './seguimiento-editar.component.css'
})
export class SeguimientoEditarComponent {


  modal = false;
  seguimientoetapa1: any[] = [];
  seguimientoetapa2: any[] = []
  seguimientoetapa3: any[] = []
  seguimientoetapa4: any[] = []
  seguimientoetapa5: any[] = []
  seguimientoetapa6: any[] = []
  seguimientoetapa7: any[] = []
  constructor(private seguimietoDatos: SeguimientoDatosByIdService, private authService : AuthService) {

  }


  decodeDatos:any
  perfildeSesion : any

  ngOnInit(): void {
    this.postNombreCasoParaTraerLosSeguimientos()
    const decode = this.authService.decodeToken();
    if (decode) {
      this.decodeDatos = decode;
      this.perfildeSesion = this.decodeDatos.roles;
    }
  }


  componente: string = '';
  etapa: string = '';
  estado: string = '';

  mostrarmodal(etapa: string, estado: string) {
    this.etapa = etapa;
    this.estado = estado;
    this.modal = !this.modal;
  }

  cerrarmodal() {
    this.modal = !this.modal;

  }

  datosSeguimientoId: any = []
  nombreCaso: any = ''
  tipodeservicio : any
  estadoGarantia: any = ''
  repuestos: any = ''
  postNombreCasoParaTraerLosSeguimientos() {
    const numerocaso = localStorage.getItem('numerocaso');
    const url = import.meta.env.NG_APP_API + '/search-seguimiento-client';
    this.nombreCaso = numerocaso;
    const datos = {
      nrCaso: numerocaso
    };
    this.seguimietoDatos.postApi(url, datos).subscribe({
      next: (data) => {
        console.log('Datos de seguimiento', data);
        this.datosSeguimientoId = data;

               
        this.tipodeservicio = this.datosSeguimientoId.caso.tipoServicio;

        this.seguimientoetapa1 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 1);
        this.seguimientoetapa2 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 2);
        this.seguimientoetapa3 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 3);
        this.seguimientoetapa4 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 4);
        this.seguimientoetapa5 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 5);
        this.seguimientoetapa6 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 6);
        this.seguimientoetapa7 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 7);
        this.estadoGarantia = data.diagnostico?.estadoGarantia
        this.repuestos = this.seguimientoetapa4[0]?.repuestos

      },
      error: (error) => {
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

}
