import { Component, Input } from '@angular/core';
import { initFlowbite } from 'flowbite';
import { ServiceService } from '../../../../core/service/service.service';

@Component({
  selector: 'app-get-registrar-casos',
  standalone: true,
  imports: [],
  templateUrl: './get-registrar-casos.component.html',
  styleUrl: './get-registrar-casos.component.css'
})
export class GetRegistrarCasosComponent {

  constructor(private casoservicio: ServiceService){}

  @Input() datos: any = {}; // Cambiado de any[] a any
  seguimientoetapa1: any[] = []
  idCaso: number = 0;
  casos : any
  imagenes: any[] = []

  urlMedia = import.meta.env.NG_APP_API + '/media/'

  tipodeDocumento: any

  areaPerteneciente: any
  usuarioRegistro: any

  horadeInicio : any

  ngOnInit(): void {
    if (this.datos && this.datos.caso) {
      this.casos=  this.datos.caso;
      console.log(this.casos)
      this.tipodeDocumento = this.casos?.cliente?.tipoDocumento || ""
      this.areaPerteneciente = this.casos?.areaPerteneciente || ""
      this.usuarioRegistro = this.casos?.usuarioRegistro || ""
      this.idCaso = this.datos.caso.id;
      this.seguimientoetapa1 = this.datos.seguimientos.filter((item: any) => item.etapa.id === 1);
      

      this.horadeInicio = this.convertirHora(this.seguimientoetapa1[0].horaInicio)
      console.log(this.horadeInicio)
    }
    this.jalarImagenesId()
  }

  

  jalarImagenesId(){
    const url = import.meta.env.NG_APP_API + '/casos/' + this.idCaso 
    this.casoservicio.getApi(url).subscribe({
      next: (data: any) => {
        this.imagenes = data.media.imagenes
      },
      error: (error) => {
        console.log(error)
      }
    })
  }

   convertirHora(horaFin) {
    // Dividir la hora, minutos y segundos
    const [hours, minutes, seconds] = horaFin.split(':');

    // Convertir la parte de horas a un número
    let hoursNumber = parseInt(hours, 10);

    // Determinar AM o PM
    const period = hoursNumber >= 12 ? 'PM' : 'AM';

    // Convertir a formato de 12 horas
    hoursNumber = hoursNumber % 12 || 12;

    // Devolver la hora en formato h:mm:ss A
    return `${hoursNumber}:${minutes}:${seconds.split('.')[0]} ${period}`;
}

}
