import { Component, Input } from '@angular/core';
import Swal from 'sweetalert2';
import { ServiceService } from '../../../core/service/service.service';
import { initFlowbite } from 'flowbite';

@Component({
  selector: 'app-abriretapa2',
  standalone: true,
  imports: [],
  templateUrl: './abriretapa2.component.html',
  styleUrl: './abriretapa2.component.css',
})
export class Abriretapa2Component {
  @Input() datos: any = {}; // Cambiado de any[] a any

  idCaso: number = 0;
  horaFin: string = '';
  fechaFIn: string = '';
  loading: boolean = false;

  fechaenvio: string = '';
  horaenvio: string = '';
  casosActualizar: any;

  constructor(private dataService: ServiceService) {}
  ngOnInit(): void {
    initFlowbite();
    if (this.datos && this.datos.caso) {
      this.casosActualizar = this.datos.caso;
      console.log(this.casosActualizar);

      const idcaso = this.datos.caso.id;
      this.idCaso = idcaso;
      this.horaFin = this.datos.seguimientos[0].horaFin;
      this.fechaFIn = this.datos.seguimientos[0].fechaFin;
    }
  }

  //DE ACA INICI LA LOGICA PARA MANEJAR LA RESPYUESTA SI ES SI O NO
  selectedOption: string = '';
  seleccionarRespuesta(event: any) {
    this.selectedOption = event.target.value;
  }

  archivosPdf: any[] = [];
  lastSelectedFiles: any 

  changePdf(e: any) {
    const files = e.target.files;

    const input = e.target;
    if (input.files && input.files.length > 0) {
      // Almacenar los archivos seleccionados
      this.lastSelectedFiles = input.files;
    } else {
      // Restaurar los archivos seleccionados anteriormente si no se seleccionan nuevos archivos
      if (this.lastSelectedFiles) {
        const dataTransfer = new DataTransfer();
        for (let i = 0; i < this.lastSelectedFiles.length; i++) {
          dataTransfer.items.add(this.lastSelectedFiles[i]);
        }
        input.files = dataTransfer.files;
      }
    }

    for (let i = 0; i < files.length; i++) {
      const file = files[i];
      const guardarFileyURL = { file: file, url: URL.createObjectURL(file) };

      const dataPdf = this.archivosPdf.find(
        (data: any) => data.file.name.toLowerCase() === file.name.toLowerCase()
      );
      if (dataPdf) {
        alert('PDF repetido!');
      } else if (this.archivosPdf.length === 1) {
        alert('Solo se Admite un pdf');
        break; // Salir del bucle si se alcanza el límite
      } else {
        this.archivosPdf.push(guardarFileyURL);
      }
    }
  }

  removePdf(url: string) {
    const index = this.archivosPdf.findIndex((item: any) => item.url === url);
    if (index !== -1) {
      this.archivosPdf.splice(index, 1);
    }

    if (this.archivosPdf.length === 0) {
      const fileInput = document.getElementById(
        'file_input_pdf'
      ) as HTMLInputElement;
      fileInput.value = '';
    }
  }

  numerodecaso: string = '';

  agarrarNumeroCaso(event: any) {
    this.numerodecaso = event.target.value;
  }

  abrirEtapa(e: any) {
    e.preventDefault();
    this.loading = true;
    if (this.loading) {
      if (this.selectedOption === 'NO') {
        Swal.fire({
          title: 'Solicitando...',
          html: `
            <style>
              .spinner {
                border: 4px solid rgba(0, 0, 0, 0.1);
                width: 36px;
                height: 36px;
                border-radius: 50%;
                border-left-color: #09f;
                animation: spin 1s linear infinite;
                display: inline-block;
                margin-top: 10px;
              }
        
              @keyframes spin {
                0% {
                  transform: rotate(0deg);
                }
                100% {
                  transform: rotate(360deg);
                }
              }
            </style>
            <div>Se está guardando la información, por favor esperar...</div>
            <div class="spinner"></div>
          `,
          icon: 'info',
          allowOutsideClick: false,
          allowEscapeKey: false,
          showConfirmButton: false,
          showCancelButton: false,
          showCloseButton: false,
          timerProgressBar: true,
        });
      } else {
        Swal.fire({
          title: 'Guardando...',
          html: `
            <style>
              .spinner {
                border: 4px solid rgba(0, 0, 0, 0.1);
                width: 36px;
                height: 36px;
                border-radius: 50%;
                border-left-color: #09f;
                animation: spin 1s linear infinite;
                display: inline-block;
                margin-top: 10px;
              }
        
              @keyframes spin {
                0% {
                  transform: rotate(0deg);
                }
                100% {
                  transform: rotate(360deg);
                }
              }
            </style>
            <div>Se está guardando la información, por favor esperar...</div>
            <div class="spinner"></div>
          `,
          icon: 'info',
          allowOutsideClick: false,
          allowEscapeKey: false,
          showConfirmButton: false,
          showCancelButton: false,
          showCloseButton: false,
          timerProgressBar: true,
        });
      }
    }
    const fecha = new Date();
    const dia = fecha.getUTCDate();
    const mes = fecha.getUTCMonth() + 1; // Los meses comienzan desde 0
    const anio = fecha.getUTCFullYear();

    // Formatear la fecha
    const fechaFormateada = `${anio}-${mes < 10 ? '0' + mes : mes}-${
      dia < 10 ? '0' + dia : dia
    }`;

    // Obtener la hora en formato de 24 horas
    const hora = fecha.getUTCHours();
    const minuto = fecha.getUTCMinutes();
    const segundo = fecha.getUTCSeconds();
    const milisegundo = fecha.getUTCMilliseconds();

    // Formatear la hora
    const horaFormateada = `${hora < 10 ? '0' + hora : hora}:${
      minuto < 10 ? '0' + minuto : minuto
    }:${segundo < 10 ? '0' + segundo : segundo}.${milisegundo}`;

    // Asignar los valores de fecha y hora obtenidos al objeto
    this.fechaenvio = fechaFormateada;
    this.horaenvio = horaFormateada;

    if (this.selectedOption === 'SI') {
      this.RepuestaSi_Enviodedatos();
    } else if (this.selectedOption === 'NO') {
      this.RepuestaNo_Enviodedatos();
    }
  }

  RepuestaSi_Enviodedatos() {
    const formData = new FormData();
    formData.append('idCaso', String(this.idCaso));
    formData.append('idEtapa', '2');
    formData.append('nroCasoMarca', this.numerodecaso);
    formData.append(
      'descripcion',
      'EL CLIENTE TRAJO EL NUMERO DE CASO ADELANTADO'
    );
    formData.append(
      'observacion',
      'SE REGISTRO EL NUMERO DE CASO POR ADELANTADO'
    );
    formData.append('repuestos', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('conformidadDeServicio', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('fechaInicio', this.fechaFIn);
    formData.append('fechaFin', this.fechaenvio);
    formData.append('horaInicio', this.horaFin);
    formData.append('horaFin', this.horaenvio);
    formData.append('estadoSeguimiento', 'Completado');

    const url = import.meta.env.NG_APP_API + '/seguimiento';

    this.dataService.postApi(url, formData).subscribe({
      next: (data) => {
        this.actualizarEnCasoDeSi()
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

  RepuestaNo_Enviodedatos() {
    const formData = new FormData();
    formData.append('idCaso', String(this.idCaso));
    formData.append('idEtapa', '2');
    formData.append('nroCasoMarca', 'EL CAS NO ENVIO EL NUMERO DE CASO');
    formData.append(
      'descripcion',
      'ESPERANDO QUE EL CAS ENVIE EL NUMERO DE CASO'
    );
    formData.append(
      'observacion',
      'YA SE HA SOLICITADO EL NUMERO DE CASO AL CAS'
    );
    formData.append('repuestos', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('conformidadDeServicio', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('fechaInicio', this.fechaFIn);
    formData.append('fechaFin', this.fechaenvio);
    formData.append('horaInicio', this.horaFin);
    formData.append('horaFin', this.horaenvio);
    for (let i = 0; i < this.archivosPdf.length; i++) {
      formData.append('pdf[]', this.archivosPdf[i].file, this.archivosPdf[i].file.name);
    }
    formData.append('estadoSeguimiento', 'Pendiente');

    const url = import.meta.env.NG_APP_API + '/seguimiento';

    this.dataService.postApi(url, formData).subscribe({
      next: (data) => {
         this.actualizarEnCasoDeno();
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }


  actualizarEnCasoDeno() {
    const formData = new FormData();
    formData.append('idCliente', this.casosActualizar.cliente.id);
    formData.append('tipoServicio', this.casosActualizar.tipoServicio);
    formData.append('descripcion', this.casosActualizar.descripcion);
    formData.append('observaciones', this.casosActualizar.observaciones);
    formData.append('numeroCaso', this.casosActualizar.numeroCaso);
    formData.append('numSerie', this.casosActualizar.numeroSerie);
    formData.append('calificacion', "");
    formData.append('etapa', '2');
    formData.append('estadoCaso', 'Pendiente');
    formData.append('aceptoTerminos', 'True');
    formData.append('ordenServicio', this.casosActualizar.ordenServicio);
    formData.append('idEquipo', this.casosActualizar.equipo.id);
    formData.append('idUsuarioAsignado', this.casosActualizar.usuarioAsignado.id);
    formData.append('proximoMantenimiento', "");
    formData.append('idPrioridadAtencion', this.casosActualizar.idPrioridad);
    formData.append('garantia', this.casosActualizar.garantia);
    formData.append('idSucursal', this.casosActualizar.sucursal.id);
    formData.append('periodoGarantiaMeses', this.casosActualizar.periodoGarantiaMeses);
    formData.append('areaPerteneciente', this.casosActualizar.areaPerteneciente || '');
    formData.append('usuarioRegistro', this.casosActualizar.usuarioRegistro || '');
    


    const url = import.meta.env.NG_APP_API + '/casos/' + this.idCaso;
    this.dataService.putApi(url, formData).subscribe({
      next: (response) => {
        Swal.fire({
          title: '¡Éxito!',
          text: 'Se ha solictado correctamente',
          icon: 'success',
          confirmButtonText: 'Aceptar',
          allowOutsideClick: false,
          allowEscapeKey: false,
          timerProgressBar: true,
        }).then((result) => {
          if (result.isConfirmed) {
            window.location.reload();
          }
        });
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

  actualizarEnCasoDeSi() {
    const formData = new FormData();
    formData.append('idCliente', this.casosActualizar.cliente.id);
    formData.append('tipoServicio', this.casosActualizar.tipoServicio);
    formData.append('descripcion', this.casosActualizar.descripcion);
    formData.append('observaciones', this.casosActualizar.observaciones);
    formData.append('numeroCaso', this.casosActualizar.numeroCaso);
    formData.append('numSerie', this.casosActualizar.numeroSerie);
    formData.append('calificacion', "");
    formData.append('etapa', '2');
    formData.append('estadoCaso', 'Completado');
    formData.append('aceptoTerminos', 'True');
    formData.append('ordenServicio', this.casosActualizar.ordenServicio);
    formData.append('idEquipo', this.casosActualizar.equipo.id);
    formData.append('idUsuarioAsignado', this.casosActualizar.usuarioAsignado.id);
    formData.append('proximoMantenimiento', "");
    formData.append('idPrioridadAtencion', this.casosActualizar.idPrioridad);
    formData.append('garantia', this.casosActualizar.garantia);
    formData.append('idSucursal', this.casosActualizar.sucursal.id);
    formData.append('periodoGarantiaMeses', this.casosActualizar.periodoGarantiaMeses);
    formData.append('areaPerteneciente', this.casosActualizar.areaPerteneciente || '');
    formData.append('usuarioRegistro', this.casosActualizar.usuarioRegistro || '');


    const url = import.meta.env.NG_APP_API + '/casos/' + this.idCaso;
    this.dataService.putApi(url, formData).subscribe({
      next: (response) => {
        Swal.fire({
          title: '¡Éxito!',
          text: 'Se ha guardado correctamente',
          icon: 'success',
          confirmButtonText: 'Aceptar',
          allowOutsideClick: false,
          allowEscapeKey: false,
          timerProgressBar: true,
        }).then((result) => {
          if (result.isConfirmed) {
            window.location.reload();
          }
        });
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

}
