import { Component, Input } from '@angular/core';
import { ServiceService } from '../../../core/service/service.service';
import Swal from 'sweetalert2';
import { CommonModule } from '@angular/common';

@Component({
  selector: 'app-getverdatos',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './getverdatos.component.html',
  styleUrl: './getverdatos.component.css',
})
export class GetverdatosComponent {
  constructor(private dataService: ServiceService) {}

  @Input() datos: any = {}; // Cambiado de any[] a any
  seguimientoetapa3: any[] = [];
  idCaso: number = 0;
  casos: any;
  imagenes: any[] = [];
  videos: any[] = [];
  distribuidor: any[] = [];
  archivosPDFS: any[] = [];
  urlMedia = import.meta.env.NG_APP_API + '/media/';
  urlsPds = import.meta.env.NG_APP_API + '/download-pdf/';

  archivoPdfRepuestos: any;

  fechaFormateada: any;

  mostraImpresoraDatos: number = 0;

  diagnotico: any;
  casosActualizar: any;

  horaFin: string = '';
  fechaFIn: string = '';

  llegadaDiasRepuesto: any

  descripcionRepuetos : any

  garantiaConfirmada   : any
  garantiaInicio : any
  ngOnInit(): void {
    if (this.datos && this.datos.caso) {
      this.casos = this.datos;
      this.casosActualizar = this.datos.caso;
      console.log(this.casos);
      this.distribuidor = this.datos.diagnostico.fallas;
      this.diagnotico = this.datos.diagnostico;
      this.idCaso = this.datos.caso.id;
      // esto es todo referido a casos
      this.imagenes = this.datos.diagnostico.media.imagenes;
      this.videos = this.datos.diagnostico.media.videos;
      this.archivosPDFS = this.datos.diagnostico.rutasPdf;

      this.seguimientoetapa3 = this.datos.seguimientos.filter(
        (item: any) => item.etapa.id === 3
      );

      this.garantiaConfirmada = this.seguimientoetapa3[0].estadoSeguimiento

      this.garantiaInicio = this.datos?.caso?.garantia
      console.log(this.garantiaInicio)

      this.archivoPdfRepuestos = this.seguimientoetapa3[0].rutasPdf;
      this.horaFin = this.seguimientoetapa3[0].horaFin;
      this.fechaFIn = this.seguimientoetapa3[0].fechaFin;

      this.llegadaDiasRepuesto = String(this.seguimientoetapa3[0].llegadaDiasRepuesto)
      console.log(this.llegadaDiasRepuesto)
      this.descripcionRepuetos = this.datos.diagnostico.descripcionRepuestos


    }
  }
  fechaenvio: string = '';
  horaenvio: string = '';
  loading: boolean = false;

  clickSoloResponderCAS(e: any) {
    e.preventDefault();
    this.loading = true;
    if (this.loading) {
      Swal.fire({
        title: 'Enviando Respuesta...',
        html: `
              <style>
                .spinner {
                  border: 4px solid rgba(0, 0, 0, 0.1);
                  width: 36px;
                  height: 36px;
                  border-radius: 50%;
                  border-left-color: #09f;
                  animation: spin 1s linear infinite;
                  display: inline-block;
                  margin-top: 10px;
                }
          
                @keyframes spin {
                  0% {
                    transform: rotate(0deg);
                  }
                  100% {
                    transform: rotate(360deg);
                  }
                }
              </style>
              <div>Se está guardando la información, por favor esperar...</div>
              <div class="spinner"></div>
            `,
        icon: 'info',
        allowOutsideClick: false,
        allowEscapeKey: false,
        showConfirmButton: false,
        showCancelButton: false,
        showCloseButton: false,
        timerProgressBar: true,
      });
    }
    const fecha = new Date();
    const dia = fecha.getUTCDate();
    const mes = fecha.getUTCMonth() + 1; // Los meses comienzan desde 0
    const anio = fecha.getUTCFullYear();

    // Formatear la fecha
    const fechaFormateada = `${anio}-${mes < 10 ? '0' + mes : mes}-${
      dia < 10 ? '0' + dia : dia
    }`;

    // Obtener la hora en formato de 24 horas
    const hora = fecha.getUTCHours();
    const minuto = fecha.getUTCMinutes();
    const segundo = fecha.getUTCSeconds();
    const milisegundo = fecha.getUTCMilliseconds();

    // Formatear la hora
    const horaFormateada = `${hora < 10 ? '0' + hora : hora}:${
      minuto < 10 ? '0' + minuto : minuto
    }:${segundo < 10 ? '0' + segundo : segundo}.${milisegundo}`;

    // Asignar los valores de fecha y hora obtenidos al objeto
    this.fechaenvio = fechaFormateada;
    this.horaenvio = horaFormateada;

    // Enviar los datos al servidor una vez que se hayan obtenido fecha y hora
    this.enviarDatosAlServidor();
  }

  actualizar() {
    const formData = new FormData();
    formData.append('idCliente', this.casosActualizar.cliente.id);
    formData.append('tipoServicio', this.casosActualizar.tipoServicio);
    formData.append('descripcion', this.casosActualizar.descripcion);
    formData.append('observaciones', this.casosActualizar.observaciones);
    formData.append('numeroCaso', this.casosActualizar.numeroCaso);
    formData.append('numSerie', this.casosActualizar.numeroSerie);
    formData.append('calificacion', '');
    formData.append('etapa', '3');
    formData.append('estadoCaso', 'Enviado');
    formData.append('aceptoTerminos', 'True');
    formData.append('ordenServicio', this.casosActualizar.ordenServicio);
    formData.append('idEquipo', this.casosActualizar.equipo.id);
    formData.append(
      'idUsuarioAsignado',
      this.casosActualizar.usuarioAsignado.id
    );
    formData.append('proximoMantenimiento', '');
    formData.append('idPrioridadAtencion', this.casosActualizar.idPrioridad);
    formData.append('garantia', this.casosActualizar.garantia);
    formData.append('idSucursal', this.casosActualizar.sucursal.id);
    formData.append(
      'periodoGarantiaMeses',
      this.casosActualizar.periodoGarantiaMeses
    );

    const url = import.meta.env.NG_APP_API + '/casos/' + this.idCaso;
    this.dataService.putApi(url, formData).subscribe({
      next: (response) => {
        Swal.fire({
          title: '¡Éxito!',
          text: 'Se registro exitosamente.',
          icon: 'success',
          confirmButtonText: 'Aceptar',
        }).then((result) => {
          if (result.isConfirmed) {
            window.location.reload();
          }
        });
      },
      error: (error) => {
        console.log(error);
        Swal.fire({
          title: '¡Error!',
          text: 'Ha ocurrido un error',
          icon: 'error',
          confirmButtonText: 'Aceptar',
        });
        this.loading = false;
      },
    });
  }

  enviarDatosAlServidor() {
    const formData = new FormData();
    formData.append('idCaso', String(this.idCaso));
    formData.append('idEtapa', '3');
    formData.append(
      'nroCasoMarca',
      'EL NUMERO DE CASO YA ESTA REGISTRADO EN LA ETAPA 2'
    );
    formData.append('descripcion', 'SE ABRIO LA ETAPA DIAGNOSTICO');
    formData.append(
      'observacion',
      'EN ESTA ETAPA SE REALIZA EL DIAGNOSTICO DEL EQUIPO CON TODAS LAS PRUEBAS CORRESPONDIENTES'
    );
    formData.append('repuestos', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('conformidadDeServicio', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('fechaInicio', this.fechaFIn);
    formData.append('fechaFin', this.fechaenvio);
    formData.append('horaInicio', this.horaFin);
    formData.append('horaFin', this.horaenvio);
    formData.append('estadoSeguimiento', 'Enviado');
    formData.append('llegadaDiasRepuesto', String(this.seguimientoetapa3[0].llegadaDiasRepuesto));

    const url =
    import.meta.env.NG_APP_API +
    '/seguimiento/' +
    this.seguimientoetapa3[0].idSeguimiento;

    this.dataService.putApi(url, formData).subscribe({
      next: (data) => {
        this.actualizar();
      },
      error: (error) => {
        console.log(error);
        Swal.fire({
          title: '¡Error!',
          text: 'Ha ocurrido un error . Por favor, inténtelo de nuevo.',
          icon: 'error',
          confirmButtonText: 'Aceptar',
        });
        this.loading = false;
      },
    });
  }
}
