import { Component, Input } from '@angular/core';
import { ServiceService } from '../../../core/service/service.service';
import Swal from 'sweetalert2';
import { CommonModule } from '@angular/common';

@Component({
  selector: 'app-desarrollo',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './desarrollo.component.html',
  styleUrl: './desarrollo.component.css',
})
export class DesarrolloComponent {
  constructor(private dataService: ServiceService) {}

  @Input() datos: any = {}; // Cambiado de any[] a any
  seguimientoetapa4: any[] = [];
  idCaso: number = 0;
  casosActualizar: any;
  horaFin: any;
  fechaFIn: any;
  estadoGarantia: any;
  ngOnInit(): void {
    if (this.datos && this.datos.caso) {
      this.casosActualizar = this.datos.caso;
      this.estadoGarantia = this.datos.caso.garantia;
      this.idCaso = this.datos.caso.id;
      this.seguimientoetapa4 = this.datos.seguimientos.filter(
        (item: any) => item.etapa.id === 4
      );
      this.horaFin = this.seguimientoetapa4[0].horaFin;
      this.fechaFIn = this.seguimientoetapa4[0].fechaFin;
    }
  }

  imagenes: any = [];
  mostrarModal: boolean = false;
  imagenSeleccionada: string = '';

  lastSelectedFiles4: any;

  onFileSelected(event: any) {
    const files = event.target.files;

    const input = event.target;
    if (input.files && input.files.length > 0) {
      // Almacenar los archivos seleccionados
      this.lastSelectedFiles4 = input.files;
    } else {
      // Restaurar los archivos seleccionados anteriormente si no se seleccionan nuevos archivos
      if (this.lastSelectedFiles4) {
        const dataTransfer = new DataTransfer();
        for (let i = 0; i < this.lastSelectedFiles4.length; i++) {
          dataTransfer.items.add(this.lastSelectedFiles4[i]);
        }
        input.files = dataTransfer.files;
      }
    }

    if (files) {
      for (let i = 0; i < files.length; i++) {
        const file = files[i];

        // Verificar si el archivo no supera los 10 MB
        const fileSizeInMB = file.size / (1024 * 1024);
        if (fileSizeInMB > 15) {
          alert('¡El tamaño de la imagen no debe superar los 15 MB!');
          if (this.imagenes.length === 0) {
            const fileInput = document.getElementById(
              'file_input'
            ) as HTMLInputElement;
            fileInput.value = '';
          }
          continue; // Saltar a la siguiente iteración si el archivo es demasiado grande
        }

        const imageUrl = URL.createObjectURL(file); // Obtén la URL temporal
        const guardarFileyURL = { file: file, url: imageUrl };

        // Verificar si la imagen ya está en la lista
        const existingImage = this.imagenes.find(
          (img: any) => img.file.name === file.name
        );
        if (existingImage) {
          alert('¡Imagen repetida!');
        } else if (this.imagenes.length >= 5) {
          alert('¡Ya has alcanzado el límite de 5 imágenes!');
          break; // Salir del bucle si se alcanza el límite
        } else {
          this.imagenes.push(guardarFileyURL);
        }
      }
    }
  }

  eliminarImagen(url: string) {
    const index = this.imagenes.findIndex((item: any) => item.url === url);
    if (index !== -1) {
      this.imagenes.splice(index, 1);
    }
    if (this.imagenes.length === 0) {
      const fileInput = document.getElementById(
        'file_input'
      ) as HTMLInputElement;
      fileInput.value = '';
    }
  }

  linkimagen: string = '';
  modalimg: boolean = false;
  verimagen(link: string) {
    this.linkimagen = link;
    this.modalimg = !this.modalimg;
  }
  cerrarmodalimg() {
    this.modalimg = !this.modalimg;
  }

  lastSelectedFiles5: any;
  videosFiles: any = [];
  // videos
  changevideosFiles(e: any) {
    const files = e.target.files;

    const input = e.target;
    if (input.files && input.files.length > 0) {
      // Almacenar los archivos seleccionados
      this.lastSelectedFiles5 = input.files;
    } else {
      // Restaurar los archivos seleccionados anteriormente si no se seleccionan nuevos archivos
      if (this.lastSelectedFiles5) {
        const dataTransfer = new DataTransfer();
        for (let i = 0; i < this.lastSelectedFiles5.length; i++) {
          dataTransfer.items.add(this.lastSelectedFiles5[i]);
        }
        input.files = dataTransfer.files;
      }
    }

    for (let i = 0; i < files.length; i++) {
      const file = files[i];

      // Verificar si el archivo no supera los 10 MB
      const fileSizeInMB = file.size / (1024 * 1024);
      if (fileSizeInMB > 30) {
        alert('¡El tamaño de la imagen no debe superar los 30 MB!');
        if (this.videosFiles.length === 0) {
          const fileInput = document.getElementById(
            'file_input_videos'
          ) as HTMLInputElement;
          fileInput.value = '';
        }
        continue; // Saltar a la siguiente iteración si el archivo es demasiado grande
      }
      const guardarFileyURL = { file: file, url: URL.createObjectURL(file) };

      const dataVideo = this.videosFiles.find(
        (data: any) => data.file.name.toLowerCase() === file.name.toLowerCase()
      );
      if (dataVideo) {
        alert('Video repetido!');
      } else if (this.videosFiles.length >= 5) {
        alert('¡Ya has alcanzado el límite de 5 videos!');
        break; // Salir del bucle si se alcanza el límite
      } else {
        this.videosFiles.push(guardarFileyURL);
      }
    }
  }

  removeVideo(url: string) {
    console.log(url);
    const index = this.videosFiles.findIndex((item: any) => item.url === url);
    if (index !== -1) {
      this.videosFiles.splice(index, 1);
    }
    if (this.videosFiles.length === 0) {
      const fileInput = document.getElementById(
        'file_input_videos'
      ) as HTMLInputElement;
      fileInput.value = '';
    }
  }

  linkVideo: string = '';
  modalVideo: boolean = false;
  verVideo(link: string) {
    this.linkVideo = link;
    this.modalVideo = !this.modalVideo;
  }
  cerrarmodalVideo() {
    this.modalVideo = !this.modalVideo;
  }

  repuestasDelRepuesto: any;

  changeRepuestos(e: any) {
    console.log(e.target.value);

    this.repuestasDelRepuesto = e.target.value;
  }

  observaciones: any;

  changeDescripcion(e: any) {
    const value = e.target.value; // Eliminamos espacios en blanco
    this.observaciones = value;
  }

  fechaenvio: any;
  horaenvio: any;
  loading: boolean = false;

  enviarDatos(e: any) {
    e.preventDefault();
  
    this.loading = true;
    if (this.loading) {
      Swal.fire({
        title: 'Guardando',
        html: `
          <style>
            .spinner {
              border: 4px solid rgba(0, 0, 0, 0.1);
              width: 36px;
              height: 36px;
              border-radius: 50%;
              border-left-color: #09f;
              animation: spin 1s linear infinite;
              display: inline-block;
              margin-top: 10px;
            }
      
            @keyframes spin {
              0% {
                transform: rotate(0deg);
              }
              100% {
                transform: rotate(360deg);
              }
            }
          </style>
          <div>Se está guardando la información, por favor espera...</div>
          <div class="spinner"></div>
        `,
        icon: 'info',
        allowOutsideClick: false,
        allowEscapeKey: false,
        showConfirmButton: false,
        showCancelButton: false,
        showCloseButton: false,
        timerProgressBar: true,
      });
    }
  
    const formData = new FormData(e.target);
  
    // Combina los dos arreglos en uno solo
    const mediaFiles = [...this.imagenes, ...this.videosFiles];


    this.observaciones = formData.get('repuestos') || '';
    // Agrega los archivos al FormData
    for (let i = 0; i < mediaFiles.length; i++) {
      formData.append('media[]', mediaFiles[i].file, mediaFiles[i].file.name);
    }
  
    // Agregar el ID de seguimiento al FormData si existe
    if (this.seguimientoetapa4 && this.seguimientoetapa4.length > 0) {
      formData.append(
        'seguimientoId',
        String(this.seguimientoetapa4[0].idSeguimiento)
      );
    }
  
    const url = import.meta.env.NG_APP_API + '/desarrollo';
  
    // Realiza la solicitud POST para guardar la información
    this.dataService.postApi(url, formData).subscribe({
      next: (data) => {
        const fecha = new Date();
        const dia = fecha.getUTCDate();
        const mes = fecha.getUTCMonth() + 1; // Los meses comienzan desde 0
        const anio = fecha.getUTCFullYear();
  
        // Formatear la fecha
        const fechaFormateada = `${anio}-${mes < 10 ? '0' + mes : mes}-${
          dia < 10 ? '0' + dia : dia
        }`;
  
        // Obtener la hora en formato de 24 horas
        const hora = fecha.getUTCHours();
        const minuto = fecha.getUTCMinutes();
        const segundo = fecha.getUTCSeconds();
        const milisegundo = fecha.getUTCMilliseconds();
  
        // Formatear la hora
        const horaFormateada = `${hora < 10 ? '0' + hora : hora}:${
          minuto < 10 ? '0' + minuto : minuto
        }:${segundo < 10 ? '0' + segundo : segundo}.${milisegundo}`;
  
        // Asignar los valores de fecha y hora obtenidos al objeto
        this.fechaenvio = fechaFormateada;
        this.horaenvio = horaFormateada;
  
        // Llamar a actualizarSeguimiento después de guardar la información
        this.actualizarSeguimiento('Completado');
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }
  
  actualizarSeguimiento(estadoActualizar: string) {
    const formData = new FormData();
    formData.append('idCaso', String(this.idCaso));
    formData.append('idEtapa', '4');
    formData.append(
      'nroCasoMarca',
      'EL NUMERO DE CASO YA ESTA REGISTRADO EN LA ETAPA 2'
    );
  
    // Agregar descripción según repuestasDelRepuesto
    if (this.repuestasDelRepuesto === 'SI') {
      formData.append('descripcion', 'SI');
    } else if (this.repuestasDelRepuesto === 'NO') {
      formData.append('descripcion', 'NO');
    }
  
    // Asegurarse de que observacion se añada solo si tiene contenido
    if (this.observaciones.trim() !== '') {
      formData.append('observacion', this.observaciones);
    } else {
      formData.append('observacion', '');
    }
  
    formData.append('repuestos', 'NO HAY REGISTRO DE REPUESTOS EN ESTA ETAPA');
    formData.append('conformidadDeServicio', 'NO HAY REGISTRO TODAVIA DE ESTO');
    formData.append('fechaInicio', this.fechaFIn);
    formData.append('fechaFin', this.fechaenvio);
    formData.append('horaInicio', this.horaFin);
    formData.append('horaFin', this.horaenvio);
    formData.append('estadoSeguimiento', estadoActualizar);
  
    // Construir la URL para la solicitud PUT
    const url =
      import.meta.env.NG_APP_API +
      '/seguimiento/' +
      this.seguimientoetapa4[0].idSeguimiento;
  
    // Realizar la solicitud PUT para actualizar seguimiento
    this.dataService.putApi(url, formData).subscribe({
      next: (data) => {
        // Después de actualizar el seguimiento, procede a actualizar casos
        this.actualizarCasos('Completado');
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }


  actualizarCasos(estadoActualizar: string) {
    const formData = new FormData();
    formData.append('idCliente', this.casosActualizar.cliente.id);
    formData.append('tipoServicio', this.casosActualizar.tipoServicio);
    formData.append('descripcion', this.casosActualizar.descripcion);
    formData.append('observaciones', this.casosActualizar.observaciones);
    formData.append('numeroCaso', this.casosActualizar.numeroCaso);
    formData.append('numSerie', this.casosActualizar.numeroSerie);
    formData.append('calificacion', '');

    if (this.estadoGarantia === 'false') {
      formData.append('etapa', '3');
    } else {
      formData.append('etapa', '4');
    }

    formData.append('estadoCaso', estadoActualizar);
    formData.append('aceptoTerminos', 'True');
    formData.append('ordenServicio', this.casosActualizar.ordenServicio);
    formData.append('idEquipo', this.casosActualizar.equipo.id);
    formData.append(
      'idUsuarioAsignado',
      this.casosActualizar.usuarioAsignado.id
    );
    formData.append('proximoMantenimiento', '');
    formData.append('idPrioridadAtencion', this.casosActualizar.idPrioridad);
    formData.append('garantia', this.casosActualizar.garantia);
    formData.append('idSucursal', this.casosActualizar.sucursal.id);
    formData.append(
      'periodoGarantiaMeses',
      this.casosActualizar.periodoGarantiaMeses
    );
    formData.append('areaPerteneciente', this.casosActualizar.areaPerteneciente || '');
    formData.append('usuarioRegistro', this.casosActualizar.usuarioRegistro || '');

    const url = import.meta.env.NG_APP_API + '/casos/' + this.idCaso;
    this.dataService.putApi(url, formData).subscribe({
      next: (response) => {
        Swal.fire({
          title: '¡Éxito!',
          text: 'Se registro exitosamente.',
          icon: 'success',
          confirmButtonText: 'Aceptar',
          allowOutsideClick: false,
          allowEscapeKey: false,
          timerProgressBar: true,
        }).then((result) => {
          if (result.isConfirmed) {
            window.location.reload();
          }
        });
      },
      error: (error) => {
        this.loading = false;
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

 
}
