import { Component, Input } from '@angular/core';
import { ServiceService } from '../../../core/service/service.service';

@Component({
  selector: 'app-getdatosetap5',
  standalone: true,
  imports: [],
  templateUrl: './getdatosetap5.component.html',
  styleUrl: './getdatosetap5.component.css'
})
export class Getdatosetap5Component {
  constructor(private casoservicio: ServiceService){}

  @Input() datos: any = {}; // Cambiado de any[] a any
  seguimientoetapa5: any[] = []
  idCaso: number = 0;
  casos : any
  imagenes: any[] = []
  videos: any[] = []
  distribuidor: any[] = []
  archivosPDFS: any[] = []
  urlMedia = import.meta.env.NG_APP_API + '/media/'
  urlsPds = import.meta.env.NG_APP_API + '/download-pdf/'

  fechaFormateada : any

  mostraImpresoraDatos : number = 0

  pruebasCalidad: any
  descripcionDetalleConsumiblesValidar : any
  ngOnInit(): void {
    if (this.datos && this.datos.caso) {
      this.casos=  this.datos;

      this.pruebasCalidad = this.datos.pruebaCalidad;
      
      this.descripcionDetalleConsumiblesValidar = this.datos.diagnostico.detalleConsumibles

      this.idCaso = this.datos.caso.id;
      this.imagenes = this.datos.pruebaCalidad.media.imagenes;
      this.videos = this.datos.pruebaCalidad.media.videos;
      this.archivosPDFS = this.datos.pruebaCalidad.rutasPdf;
      this.seguimientoetapa5 = this.datos.seguimientos.filter((item: any) => item.etapa.id === 5);
      this.fechaFormateada = this.formatearFecha(this.datos.caso.proximoMantenimiento);
    }
  }

  formatearFecha(fecha: string): string {
    const opciones: Intl.DateTimeFormatOptions = { day: '2-digit', month: 'long', year: 'numeric' };
    const fechaObj = new Date(fecha);
    return fechaObj.toLocaleDateString('es-ES', opciones);
  }
}
