import { HttpClient } from '@angular/common/http';
import { Component } from '@angular/core';
import pdfMake from 'pdfmake/build/pdfmake';
import pdfFonts from 'pdfmake/build/vfs_fonts';
import { SeguimientoDatosByIdService } from '../../../dashboard/modules/casos/casos/tablacasos/seguimientodatosbyid';
import { CommonModule } from '@angular/common';
pdfMake.vfs = pdfFonts.pdfMake.vfs;
@Component({
  selector: 'app-getetapa6',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './getetapa6.component.html',
  styleUrl: './getetapa6.component.css',
})
export class Getetapa6Component {
  modal = false;
  seguimientoetapa1: any[] = [];
  seguimientoetapa2: any[] = [];
  seguimientoetapa3: any[] = [];
  seguimientoetapa4: any[] = [];
  seguimientoetapa5: any[] = [];
  seguimientoetapa6: any[] = [];
  seguimientoetapa7: any[] = [];

  constructor(
    private seguimietoDatos: SeguimientoDatosByIdService,
    private http: HttpClient
  ) {}

  ngOnInit(): void {
    this.jalarImagenes();
    this.initializeData();
  }
  dataLoaded = false;
  async initializeData() {
    try {
      await this.postNombreCasoParaTraerLosSeguimientos();
      this.dataLoaded = true;
    } catch (error) {
      console.error('Error al cargar los datos:', error);
    }
  }

  mostrarmodal(etapa: string, estado: string) {
    this.modal = !this.modal;
  }

  cerrarmodal() {
    this.modal = !this.modal;
  }

  datosSeguimientoId: any = [];
  nombreCaso: any = '';
  estadoGarantia: any = '';
  repuestos: any = '';
  fechaInicioEtapa1: any;
  fechaInicioEtapa6: any;

  tipodeServicio: any;
  descripcionDiagnostico: any;
  descripcionDesarrollo: any;
  descripcionPruebasdeCalidad: any;

  descripcionnumerodeCaso: any;

  descripcionnumerodeCaso2: any;

  fechaSplitMantenimiento: any;
  anioMantenimiento: any;
  mesMantenimiento: any;
  diaMantenimiento: any;
  fechadeMantenimiento: any;

  anioFecha1: any;
  mesFecha1: any;
  diaFecha1: any;
  fecha1: any;

  anioFecha6: any;
  mesFecha6: any;
  diaFecha6: any;
  fecha16: any;

  numerodeCasodelCas: any;
  numerodeCasoDatatronica: any;

  fallas: any = [];

  tipodeMantenimiento: any;

  descripciondeRepuestos: any;

  observacionesdeEntrada: any;
  observacionesPruebasdeCalidad: any;

  nombreCliente: any;

  tipodeDocumento: any;

  celularcLiente: any;

  direccionCliente: any;

  osNumber: any;

  numerodeDocumento: any;

  tecnicoResponsable: any;

  marcaEquipo: any;
  tipoEquipo: any;
  modeloEquipo: any;
  serieEquipo: any;

  rangodeEstrellas: any;

  mostrarEstrellas: any;

  razonSocialEmpresa: any;

  oficinadelEquipo: any;
  represetantedelEquipo: any;

  postNombreCasoParaTraerLosSeguimientos(): Promise<void> {
    return new Promise<void>((resolve, reject) => {
      const numerocaso = localStorage.getItem('numerocaso');
      if (!numerocaso) {
        console.error('Número de caso no encontrado en el almacenamiento local.');
        reject();
        return;
      }
  
      const url = import.meta.env.NG_APP_API + '/search-seguimiento-client';
      this.nombreCaso = numerocaso;
      const datos = { nrCaso: numerocaso };
  
      this.seguimietoDatos.postApi(url, datos).subscribe({
        next: (data) => {
          this.datosSeguimientoId = data;
          console.log('Datos de seguimiento por ID:', this.datosSeguimientoId);
  
          // INFORMACION GENERAL
          this.rangodeEstrellas = this.datosSeguimientoId?.caso?.calificacion ?? 'No hay calificación';
          console.log(this.rangodeEstrellas);
  
          this.oficinadelEquipo = this.datosSeguimientoId?.caso?.areaPerteneciente?.toUpperCase() ?? 'No hay registro de área perteneciente';
          this.represetantedelEquipo = this.datosSeguimientoId?.caso?.usuarioRegistro?.toUpperCase() ?? 'No hay registro de representante del equipo';
          console.log(this.oficinadelEquipo, this.represetantedelEquipo);
  
          const nombre = this.datosSeguimientoId?.caso?.cliente?.nombre ?? '';
          const apellido = this.datosSeguimientoId?.caso?.cliente?.apellido ?? '';
          this.nombreCliente = `${nombre} ${apellido}`.trim().toUpperCase() || 'No hay registro de nombre del cliente';
  
          this.tipodeDocumento = this.datosSeguimientoId?.caso?.cliente?.tipoDocumento?.trim().toUpperCase() ?? 'No hay registro de tipo de documento';
  
          this.razonSocialEmpresa = this.datosSeguimientoId?.caso?.cliente?.representanteLegal?.toUpperCase() ?? 'No hay registro de razón social';
  
          this.celularcLiente = this.datosSeguimientoId?.caso?.cliente?.celularesContacto ?? 'No hay registro de celular de cliente';
          this.tipodeServicio = this.datosSeguimientoId?.caso?.tipoServicio?.toUpperCase() ?? 'No hay registro de tipo de servicio';
  
          this.direccionCliente = this.datosSeguimientoId?.caso?.cliente?.direccionLegal?.trim().toUpperCase() ?? 'No hay registro de dirección del cliente';
  
          this.numerodeDocumento = this.datosSeguimientoId?.caso?.cliente?.numeroDocumento?.trim().toUpperCase() ?? 'No hay registro de número de documento';
  
          this.tecnicoResponsable = this.datosSeguimientoId?.caso?.usuarioAsignado?.nombres?.trim().toUpperCase() ?? 'No hay registro de técnico responsable';
  
          // equipos
          this.marcaEquipo = this.datosSeguimientoId?.caso?.equipo?.marca?.toUpperCase() ?? 'No hay registro de marca de equipo';
          this.tipoEquipo = this.datosSeguimientoId?.caso?.equipo?.color?.toUpperCase() ?? 'No hay registro de tipo de equipo';
          this.modeloEquipo = this.datosSeguimientoId?.caso?.equipo?.modelo?.toUpperCase() ?? 'No hay registro de modelo de equipo';
          this.serieEquipo = this.datosSeguimientoId?.caso?.numeroSerie?.toUpperCase() ?? 'No hay registro de serie de equipo';
  
          this.descripcionDiagnostico = this.datosSeguimientoId?.diagnostico?.descripcion?.toUpperCase() ?? 'No hay registro de descripción de diagnóstico';
          this.descripcionDesarrollo = this.datosSeguimientoId?.desarrollo?.descripcion?.toUpperCase() ?? 'No hay registro de descripción de desarrollo';
          this.descripcionPruebasdeCalidad = this.datosSeguimientoId?.pruebaCalidad?.descripcion?.toUpperCase() ?? 'No hay registro de descripción de pruebas de calidad';
  
          // Dividir la fecha
          if (this.datosSeguimientoId?.caso?.proximoMantenimiento) {
            this.fechaSplitMantenimiento = this.datosSeguimientoId.caso.proximoMantenimiento.split('-');
  
            // Obtener los componentes de la fecha
            this.anioMantenimiento = this.fechaSplitMantenimiento[0];
            this.mesMantenimiento = this.fechaSplitMantenimiento[1];
            this.diaMantenimiento = this.fechaSplitMantenimiento[2];
  
            // Reconstruir la fecha en formato día-mes-año
            this.fechadeMantenimiento = `${this.diaMantenimiento}-${this.mesMantenimiento}-${this.anioMantenimiento}`;
            console.log(this.fechadeMantenimiento); // Para verificar la fecha reconstruida
          } else {
            this.fechadeMantenimiento = 'No hay registro de fecha de mantenimiento';
          }
  
          this.seguimientoetapa1 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 1) ?? [];
          this.seguimientoetapa2 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 2) ?? [];
          this.seguimientoetapa3 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 3) ?? [];
          this.seguimientoetapa4 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 4) ?? [];
          this.seguimientoetapa5 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 5) ?? [];
          this.seguimientoetapa6 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 6) ?? [];
          this.seguimientoetapa7 = this.datosSeguimientoId?.seguimientos?.filter((item: any) => item.etapa.id === 7) ?? [];
  
          // Asignación condicional usando una expresión ternaria
          this.descripciondeRepuestos = this.datosSeguimientoId?.diagnostico?.descripcionRepuestos?.toUpperCase() ?? 'NO SE NECESITARON REPUESTOS PARA ESTE CASO';
  
          this.observacionesdeEntrada = this.datosSeguimientoId?.caso?.observaciones?.trim().toUpperCase() ?? 'No hay registro de observaciones de entrada';
          this.tipodeMantenimiento = this.datosSeguimientoId?.diagnostico?.tipomantenimiento?.descripcion?.toUpperCase() ?? 'No hay registro de tipo de mantenimiento';
          this.observacionesPruebasdeCalidad = this.datosSeguimientoId?.pruebaCalidad?.observaciones?.toUpperCase() ?? 'No hay registro de observaciones de pruebas de calidad';
          this.fallas = this.datosSeguimientoId?.diagnostico?.fallas ?? [];
  
          this.numerodeCasoDatatronica = this.datosSeguimientoId?.caso?.numeroCaso ?? 'No hay registro de número de caso Datatronica';
          this.numerodeCasodelCas = this.seguimientoetapa2[0]?.nroCasoMarca ?? 'No registro';
          console.log(this.numerodeCasodelCas, this.numerodeCasoDatatronica);
  
          this.descripcionnumerodeCaso = this.seguimientoetapa2[0]?.descripcion?.toUpperCase() ?? 'No hay registro de descripción de número de caso';
          this.estadoGarantia = data.diagnostico?.estadoGarantia ?? 'No hay registro de estado de garantía';
          this.repuestos = this.seguimientoetapa3[0]?.repuestos?.trim().toUpperCase() ?? 'No hay registro de repuestos';
  
          if (this.datosSeguimientoId?.seguimientos[0]?.fechaInicio) {
            this.fechaInicioEtapa1 = this.datosSeguimientoId.seguimientos[0].fechaInicio.split('-');
  
            this.anioFecha1 = this.fechaInicioEtapa1[0];
            this.mesFecha1 = this.fechaInicioEtapa1[1];
            this.diaFecha1 = this.fechaInicioEtapa1[2];
  
            this.fecha1 = `${this.diaFecha1}-${this.mesFecha1}-${this.anioFecha1}`;
            console.log(this.fecha1);
          } else {
            this.fecha1 = 'No hay registro de fecha de inicio de la etapa 1';
          }
  
          if (this.seguimientoetapa6[0]?.fechaFin) {
            this.fechaInicioEtapa6 = this.seguimientoetapa6[0].fechaFin.split('-');
  
            this.anioFecha6 = this.fechaInicioEtapa6[0];
            this.mesFecha6 = this.fechaInicioEtapa6[1];
            this.diaFecha6 = this.fechaInicioEtapa6[2];
  
            this.fecha16 = `${this.diaFecha6}-${this.mesFecha6}-${this.anioFecha6}`;
          } else {
            this.fecha16 = 'No hay registro de fecha de fin de la etapa 6';
          }
  
          this.osNumber = this.numerodeCasodelCas.length > 0
            ? this.numerodeCasodelCas
            : this.numerodeCasoDatatronica;
          console.log(this.osNumber);
  
          resolve();
        },
        error: (error) => {
          console.error('Error al obtener los datos de seguimiento:', error);
          reject();
        },
      });
    });
  }
  
  base64data: string | ArrayBuffer | null;
  estrella1: string | ArrayBuffer | null;
  estrella2: string | ArrayBuffer | null;
  estrella3: string | ArrayBuffer | null;
  estrella4: string | ArrayBuffer | null;
  estrella5: string | ArrayBuffer | null;

  jalarImagenes() {
    // Carga la primera imagen desde los assets
    this.http
      .get('../assets/img/logodatatronica.png', { responseType: 'blob' })
      .subscribe((blob1) => {
        const reader1 = new FileReader();
        reader1.readAsDataURL(blob1);
        reader1.onloadend = () => {
          this.base64data = reader1.result;
        };
      });

    // Carga la segunda imagen desde los assets
    this.http
      .get('../assets/img/estrella (1).png', { responseType: 'blob' })
      .subscribe((blob2) => {
        const reader2 = new FileReader();
        reader2.readAsDataURL(blob2);
        reader2.onloadend = () => {
          this.estrella1 = reader2.result;
        };
      });
    // Carga la segunda imagen desde los assets
    this.http
      .get('../assets/img/estrella (2).png', { responseType: 'blob' })
      .subscribe((blob2) => {
        const reader2 = new FileReader();
        reader2.readAsDataURL(blob2);
        reader2.onloadend = () => {
          this.estrella2 = reader2.result;
        };
      });

    // Carga la segunda imagen desde los assets
    this.http
      .get('../assets/img/estrella (3).png', { responseType: 'blob' })
      .subscribe((blob2) => {
        const reader2 = new FileReader();
        reader2.readAsDataURL(blob2);
        reader2.onloadend = () => {
          this.estrella3 = reader2.result;
        };
      });

    // Carga la segunda imagen desde los assets
    this.http
      .get('../assets/img/estrella (4).png', { responseType: 'blob' })
      .subscribe((blob2) => {
        const reader2 = new FileReader();
        reader2.readAsDataURL(blob2);
        reader2.onloadend = () => {
          this.estrella4 = reader2.result;
        };
      });

    this.http
      .get('../assets/img/estrella (5).png', { responseType: 'blob' })
      .subscribe((blob2) => {
        const reader2 = new FileReader();
        reader2.readAsDataURL(blob2);
        reader2.onloadend = () => {
          this.estrella5 = reader2.result;
        };
      });
  }

  generatePdf() {
    const today = new Date();
    const year = today.getFullYear();
    const month = `${today.getMonth() + 1}`.padStart(2, '0'); // El mes es indexado desde 0
    const day = `${today.getDate()}`.padStart(2, '0');
    const formattedDate = `${year}-${month}-${day}`;

    const fileName = `Conformidad_Servicios_${formattedDate}.pdf`;

    // Lógica para seleccionar la imagen de estrella adecuada
    let estrellaImage: any;
    switch (this.rangodeEstrellas) {
      case 1:
        estrellaImage = this.estrella1;
        break;
      case 2:
        estrellaImage = this.estrella2;
        break;
      case 3:
        estrellaImage = this.estrella3;
        break;
      case 4:
        estrellaImage = this.estrella4;
        break;
      case 5:
        estrellaImage = this.estrella5;
        break;
      default:
        estrellaImage = undefined;
        break;
    }

    const pdfDefinition: any = {
      content: [
        {
          columns: [
            {
              image: this.base64data, // Asumiendo que `this.base64data` contiene tu imagen base64
              width: 150,
            },
            {
              stack: [
                {},
                { text: 'Celular : 942710264 - 959414940', alignment: 'right' },
                { text: 'www.datatronicaperu.com', alignment: 'right' },
              ],
              style: 'header',
              alignment: 'right',
              width: '*', // Ancho automático
            },
          ],
        },
        {
          style: 'tableExample',
          margin: [0, 10, 0, 10], // Añade margen superior
          table: {
            headerRows: 1,
            widths: [81, '*', 81], // Anchuras de las columnas: 200 para la primera y última, automático (*) para la segunda
            body: [
              [
                { text: '', style: 'tableHeader', alignment: 'center' },
                {
                  stack: [
                    {
                      text: 'CENTRO DE SERVICIOS AUTORIZADOS',
                      style: 'tableHeader',
                      alignment: 'center',
                      margin: [0, 0, 0, 5],
                    },
                    {
                      text: 'FORMATO DE CONFORMIDAD DE SERVICIOS',
                      style: 'tableHeader',
                      alignment: 'center',
                    },
                  ],
                  alignment: 'center',
                },
                {
                  text: `O.S: ${this.osNumber}`,
                  style: 'tableHeader',
                  alignment: 'center',
                },
              ],
              [
                {
                  text: 'INFORMACION GENERAL',
                  style: 'tableHeader',
                  alignment: 'center',
                  colSpan: 3,
                },
                {},
                {},
              ],
              [
                {
                  text: 'CLIENTE / EMPRESA:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text:
                    this.tipodeDocumento === 'DNI'
                      ? `${this.nombreCliente}`
                      : `${this.razonSocialEmpresa}, `,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },

                {
                  text: `CEL: ${this.celularcLiente}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, true, true],
                },
              ],
              [
                {
                  text: 'DNI / RUC:	',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.numerodeDocumento}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'DIRECCION:	',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.direccionCliente}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'TIPO DE SERVICIO:	',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.tipodeServicio}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'TECNICO RESPONSABLE:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.tecnicoResponsable}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'REPRESETANTE DEL EQUIPO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text:
                    this.tipodeDocumento === 'DNI'
                      ? `${this.nombreCliente}`
                      : `${this.represetantedelEquipo}, `,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'OFICINA DEL EQUIPO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.oficinadelEquipo}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],

              [
                {
                  text: 'INFORMACION EQUIPO	',
                  style: 'tableHeader',
                  alignment: 'center',
                  colSpan: 3,
                },
                {},
                {},
              ],
              [
                {
                  text: 'MARCA:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.marcaEquipo}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'TIPO EQUIPO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.tipoEquipo}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'MODELO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.modeloEquipo}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'SERIE:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.serieEquipo}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, false, true],
                },
                {
                  text: '',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                },
              ],
              [
                {
                  text: 'OBSERVACIONES DE ENTRADA:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.observacionesdeEntrada}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'FALLAS:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  ul: this.fallas.map((item: any) => ({
                    text: `${item.codigoFalla} - ${item.descripcion}`,
                    margin: [0, 5],
                  })),
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, false, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'REPUESTOS:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.descripciondeRepuestos}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'DIAGNOSTICO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.descripcionDiagnostico}`,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'DESARROLLO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.descripcionDesarrollo}
                  `,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'ESTADO FINAL DEL EQUIPO:',
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [true, true, false, true],
                },
                {
                  text: `${this.descripcionPruebasdeCalidad}
                  `,
                  style: 'tableHeader',
                  alignment: 'left',
                  border: [false, true, true, true],
                  colSpan: 2,
                },
                {},
              ],
              [
                {
                  text: 'OBSERVACIONES Y/O RECOMENDACIONES',
                  style: 'tableHeader',
                  alignment: 'center',
                  colSpan: 3,
                },
                {},
                {},
              ],
              [
                {
                  text: `Fecha Sugerida de Mantenimiento : ${this.fechadeMantenimiento},

                  ${this.observacionesPruebasdeCalidad}
                  `,
                  style: 'tableHeader',
                  alignment: 'center',
                  colSpan: 3,
                },
                {},
                {},
              ],

              // Agrega más filas según sea necesario
            ],
          },
        },
        {
          columns: [
            {
              stack: [
                { text: `Fecha Inicio : ${this.fecha1}`, alignment: 'left' },
              ],
              style: 'header',
              alignment: 'right',
              width: '*', // Ancho automático
            },
            {
              stack: [
                { text: `Fecha Fin : ${this.fecha16}`, alignment: 'right' },
              ],
              style: 'header',
              alignment: 'right',
              width: '*', // Ancho automático
            },
          ],
          margin: [0, 0, 0, 10], // Añade margen superior
        },
        {
          columns: [
            {
              stack: [
                {
                  text: 'CALIFICACION DEL SERVICIO', // Texto encima de la imagen
                  alignment: 'center',
                  margin: [0, 100, 0, 10], // Márgenes: arriba, derecha, abajo, izquierda
                },
                {
                  image: estrellaImage, // Aquí asigna tu variable base64data1 o base64data2
                  width: 150,
                  alignment: 'center',
                },
              ],
            },
          ],
        },
      ],
      styles: {
        header: {
          fontSize: 7,
          bold: true,
        },
        customStyle: {
          fontSize: 7,
          bold: true,
          color: '#4a4a4a',
        },
        tableHeader: {
          bold: true,
          fontSize: 7,
          color: 'black',
          alignment: 'center',
          // Añadido para alinear al centro si es necesario
        },
        tableData: {
          fontSize: 7,
          color: 'black',
        },
      },
    };

    const pdf = pdfMake.createPdf(pdfDefinition);
    pdf.open();
    pdf.download(fileName);
  }

  abrirVentanaEmergente() {
    console.log('click en pdf');
    // Obtener dimensiones de la pantalla
    var width = screen.availWidth;
    var height = screen.availHeight;

    // Construir la URL relativa a la vista o componente en Angular
    var rutaAngular = '/pdf'; // Reemplaza '/pdf' con la ruta que deseas abrir

    var ventanaEmergente = window.open(
      rutaAngular,
      'ventanaEmergente',
      `width=${width},height=${height},fullscreen=yes`
    );
  }
}
