import { Component, OnInit, inject } from '@angular/core';
import { GetRegistrarCasosComponent } from './etapa1/components/get-registrar-casos/get-registrar-casos.component';
import { SeguimientoDatosByIdService } from '../dashboard/modules/casos/casos/tablacasos/seguimientodatosbyid';
import { Abriseguimiento3Component } from './etapa3/abriseguimiento3/abriseguimiento3.component';
import { MensajeesperaComponent } from '../mensajeespera/mensajeespera.component';
import AuthService from '../core/auth/auth.service';
import { CommonModule } from '@angular/common';
import { Abriretapa2Component } from './etapa2/abriretapa2/abriretapa2.component';
import { DiagnosticoComponent } from './etapa3/diagnostico/diagnostico.component';
import { Abriretapa4seguimientoComponent } from './etapa4/abriretapa4seguimiento/abriretapa4seguimiento.component';
import { DesarrolloComponent } from './etapa4/desarrollo/desarrollo.component';
import { RespuestacasnumerodecasoComponent } from './etapa2/respuestacasnumerodecaso/respuestacasnumerodecaso.component';
import { VistacompletadonumerocasoComponent } from './etapa2/vistacompletadonumerocaso/vistacompletadonumerocaso.component';
import { GetverdatosComponent } from './etapa3/getverdatos/getverdatos.component';
import { Etapa4vistageneralComponent } from './etapa4/etapa4vistageneral/etapa4vistageneral.component';
import { Abrietapa5seguimientoComponent } from './etapa5/abrietapa5seguimiento/abrietapa5seguimiento.component';
import { PruebasdecalidadComponent } from './etapa5/pruebasdecalidad/pruebasdecalidad.component';
import { AsistenterespondeComponent } from './etapa3/asistenteresponde/asistenteresponde.component';
import { AbrirultimaetapaComponent } from './etapa6/abrirultimaetapa/abrirultimaetapa.component';
import { FormularioconformidadComponent } from './etapa6/formularioconformidad/formularioconformidad.component';
import { Getdatosetap5Component } from './etapa5/getdatosetap5/getdatosetap5.component';
import { Getetapa6Component } from './etapa6/getetapa6/getetapa6.component';
import { PedirplantillaComponent } from './etapa-solo-brothers/pedirplantilla/pedirplantilla.component';
import { ResponderplantillaComponent } from './etapa-solo-brothers/responderplantilla/responderplantilla.component';
import { MostrardatosComponent } from './etapa-solo-brothers/mostrardatos/mostrardatos.component';
import Swal from 'sweetalert2';


@Component({
  selector: 'app-seguimiento',
  standalone: true,
  imports: [CommonModule,MensajeesperaComponent,GetRegistrarCasosComponent, Abriretapa2Component, Abriseguimiento3Component, DiagnosticoComponent, Abriretapa4seguimientoComponent, DesarrolloComponent, RespuestacasnumerodecasoComponent, VistacompletadonumerocasoComponent, GetverdatosComponent , Abriretapa4seguimientoComponent, Etapa4vistageneralComponent, Abrietapa5seguimientoComponent, PruebasdecalidadComponent, AsistenterespondeComponent, AbrirultimaetapaComponent, FormularioconformidadComponent,Getdatosetap5Component, Getetapa6Component, PedirplantillaComponent, ResponderplantillaComponent, MostrardatosComponent],
  templateUrl: './seguimiento.component.html',
  styleUrl: './seguimiento.component.css'
})
export class SeguimientoComponent implements OnInit {

  modal = false;
  seguimientoetapa1: any[] = [];
  seguimientoetapa2: any[] = []
  seguimientoetapa3: any[] = []
  seguimientoetapa4: any[] = []
  seguimientoetapa5: any[] = []
  seguimientoetapa6: any[] = []
  seguimientoetapa7: any[] = []
  constructor(private seguimietoDatos : SeguimientoDatosByIdService, private authService: AuthService) {

  }



  decodeDatos: any;

  perfildeSesion: string = '';

  perfilDistribuidor: string = '';

  ngOnInit(): void {
    this.postNombreCasoParaTraerLosSeguimientos()
    const decode = this.authService.decodeToken();
    if (decode) {
      this.decodeDatos = decode;
      console.log(this.decodeDatos);
      this.perfilDistribuidor = this.decodeDatos.distribuidor || '';
      this.perfildeSesion = this.decodeDatos.roles;
    }
 
  }


  componente : string = '';
  etapa: string = '';
  estado: string = '';

  mostrarmodal(etapa: string, estado: string) {
    this.etapa = etapa;
    this.estado = estado;
    this.modal = !this.modal;
  }

  cerrarmodal() {
    this.modal = !this.modal;
  
  }

  datosSeguimientoId : any = []
  nombreCaso : any = ''

  estadoGarantia: any = ''
  repuestos : any = ''

  tipodeservicio: any = ''

  brother : any = ''

  garantia : any = ''

  postNombreCasoParaTraerLosSeguimientos() {
    const numerocaso = localStorage.getItem('numerocaso');
    const url = import.meta.env.NG_APP_API + '/search-seguimiento-client';
    this.nombreCaso = numerocaso;
    const datos = {
      nrCaso: numerocaso
    };
    this.seguimietoDatos.postApi(url, datos).subscribe({
      next: (data) => {
        this.datosSeguimientoId = data;

        console.log(this.brother)

        console.log(this.datosSeguimientoId)

        this.brother = this.datosSeguimientoId.caso.equipo.distribudor.nombre
        console.log(this.brother)

        this.garantia = this.datosSeguimientoId.caso.garantia
       
       
        this.tipodeservicio = this.datosSeguimientoId.caso.tipoServicio;


        this.seguimientoetapa1 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 1);

        this.seguimientoetapa2 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 2);
        
        this.seguimientoetapa3 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 3);

        this.seguimientoetapa4 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 4);

        this.seguimientoetapa5 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 5);

        this.seguimientoetapa6 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 6);

        this.seguimientoetapa7 = this.datosSeguimientoId.seguimientos.filter((item: any) => item.etapa.id === 7);
      
        this.repuestos= this.seguimientoetapa4[0]?.repuestos

 
        
      },
      error: (error) => {
        let errorMessage = 'Algo salió mal';
        if (error.error && error.error.message) {
          errorMessage = error.error.message;
        }

        Swal.fire({
          title: 'Error',
          text: errorMessage,
          icon: 'error',
          confirmButtonText: 'OK',
        });
      },
    });
  }

  


 
  

  
  
}
